/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.internal.RequestInterceptor"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;

	var PROXY_URL_PREFIX = UIHelper.getContextRoot() + "/proxy?uri="; //$NON-NLS-1$
	// normalize the port property of the current page for later comparison with
	// incoming URLs
	var LOCAL_URL = new dojo._Url(location.href); 
	UIHelper.normalizePort(LOCAL_URL);

	function intercept (request){
		var url = dojo.getObject("args.url", false, request); //$NON-NLS-1$
		if(!url)
			return;
		if(request.method === "POST" || request.method === "PUT" || request.method === "DELETE") { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if (url.indexOf(PROXY_URL_PREFIX) === 0) {
				url = url.substring(PROXY_URL_PREFIX.length);
				url = decodeURIComponent(url);
				if (UIHelper.isProcessAuthoringResourceURL(url)) {
					// convert the url to application-local url
					var index = url.indexOf(ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART);
					url = UIHelper.getContextRoot() + url.substring(index);
					request.args.url = url;
				}
			}
		}
	};
	
	function gadgetIntercept (request){
		var url = dojo.getObject("args.url", false, request); //$NON-NLS-1$
		if(!url)
			return;
		var urlObj = new dojo._Url(url);
		if(gadgetIsProcessAuthoringResourceURL(url) && (!UIHelper.originsAreEquivalent(urlObj, LOCAL_URL) || !UIHelper.startWith(urlObj["path"], UIHelper.getContextRoot()))) { //$NON-NLS-1$
			// convert the url to application-local url
			var index = url.indexOf(ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART);
			url = UIHelper.getContextRoot() + url.substring(index);
			request.args.url = url;
		}
	};

	/**
	 * Have to define this function because UIHelper.isProcessAuthoringResourceURL does not work for gadget. 
	 * Error: net.jazz.ajax._oauthDomains is undefined
	 * 
	 * @param {Object} url
	 */
	function gadgetIsProcessAuthoringResourceURL(url) {
		return url.indexOf(ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART) != -1;
	}
	
	// Apply Process Authoring proxy logic to requests sent through jazz.client.xhr
	if (dojo.getObject("gadgets.io.makeRequest")) //$NON-NLS-1$
		jazz.client.internal.addRequestInterceptor(gadgetIntercept);
//	else
//		jazz.client.internal.addRequestInterceptor(intercept);
		
})();
