/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.jfs.web.ui.internal.PersonalDashboardsApplication"); //$NON-NLS-1$

dojo.require("com.ibm.team.app.web.RepositoryApplication"); //$NON-NLS-1$
dojo.require("dojo.hash");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.jfs.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("com.ibm.team.jfs.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.jfs.web.ui.internal.PersonalDashboardsApplication", com.ibm.team.app.web.RepositoryApplication, { //$NON-NLS-1$
	autoRequestInitData: false,
	iconLarge: dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/Dashboard/icons/all-dash-24.png"),
	constructor: function() {
		var hash = dojo.hash();
		if (hash.length > 0 && hash.indexOf("/") == 0) {
			var url = net.jazz.ajax._contextRoot + hash;
			var search = location.search;
			if (search) {
				url += search;
			}
			location.replace(url);
		} else {
			this.enableHtml5History();
			this.fetchInitData();
		}
	},
	initContext: function() {
		this.start();
	},
	
	enableHtml5History: function(enable) {
		//handle html5 history hash overriding
		if (typeof history.pushState !== 'undefined') {
			dojo.connect(window, "onpopstate", this, this._handlePopState);
			history.replaceState({hash: dojo.hash()||location.pathname.substring(net.jazz.ajax._contextRoot.length)},"",location.href);
			dojo.hash = (function() {
				var realHash = dojo.hash;
				return (function (hash, replace) {
					if (hash) {
						if (hash.indexOf("#") == 0) hash = hash.substring(1);
						if (dojo.isString(hash) && hash.indexOf("/")==0) {
							history[replace?"replaceState":"pushState"]({hash: hash},"", net.jazz.ajax._contextRoot + hash + location.search);
							dojo.publish("/dojo/hashchange", [hash]);
							return hash;
						}
					} else if (history.state && history.state.hash) {
						return history.state.hash;
					}
					return realHash.apply(null, arguments);
				});
			})();
		}
	},
	
	_handlePopState: function(event) {
		if (event.state && event.state.hash) {
			dojo.publish("/dojo/hashchange", [event.state.hash]);
		}
	}
});
})();