/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportsWelcome");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {

var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
var AUTHOR_CUSTOM_REPORT_URI = "#action=com.ibm.team.reports.authorCustomReport";

dojo.declare("com.ibm.team.reports.web.ui.internal.ReportsWelcome",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportsWelcome.html"),
		
		constructor: function(args) {
			this.rrdiConfigured = args.rrdiConfigured;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			var srh = new ServiceResponseHandler(this, "_handleFetchJTSUrl", "_handleFetchJTSUrlError");
			ServerStatusClient.getJazzTeamServerURI(srh);
			if (this.rrdiConfigured == true) {
				this.customReportIconLink.setAttribute("href", AUTHOR_CUSTOM_REPORT_URI);
				this.customReportTextLink.setAttribute("href", AUTHOR_CUSTOM_REPORT_URI);
				this.rrdiDescription.innerHTML = this.messages.additionalReportingDescription;
				dojo.removeClass(this.customReportTextLink, "disabled");
			} else {
				this.customReportIconLink.removeAttribute("href");
				this.customReportTextLink.removeAttribute("href");
				this.rrdiDescription.innerHTML = this.messages.rrdiRequired;
				dojo.addClass(this.customReportTextLink, "disabled");
			}
		},
		
		_handleFetchJTSUrl : function(response){
			if(response == null){
				this._handleFetchJTSUrlError();
				return;
			}
			var url = response;
			var indexOfCharAfterDoubleSlash = url.indexOf("//") + 2;
			var indexOfSlashBeforeAppName = url.indexOf("/", indexOfCharAfterDoubleSlash);
			url = url.substring(0, indexOfSlashBeforeAppName + 1);
			this._learnLink.href = url +  
				"clmhelp/topic/com.ibm.rational.rr.usage.doc/topics/c_rr_overview.html";
		},
		
		_handleFetchJTSUrlError : function(){
			this._learnLink.href = "/clmhelp/topic/com.ibm.rational.rr.usage.doc/topics/c_rr_overview.html";
		}
	}
);

})();