/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.ui.internal.editors.AbstractPracticesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ContentEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.GeneralInputFieldEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.PracticeElement"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.PracticeNavigatorData"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTree"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTreePane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.WorkingCopy"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.CopyResourceLinkDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.CollapsibleSection"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.AttachmentManager"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.MoveDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.AuthoringAccordionButton"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.LanguageJsonData"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.uuid.Uuid"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("dijit.layout.AccordionContainer"); //$NON-NLS-1$
	dojo.require("dojo.data.ItemFileReadStore"); //$NON-NLS-1$
	dojo.require("dojo.data.ItemFileWriteStore"); //$NON-NLS-1$
	dojo.require("dijit.tree.ForestStoreModel"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.underlay"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ExportDialog = com.ibm.team.process.authoring.web.ui.internal.dialogs.ExportDialog;
	var MoveDialog = com.ibm.team.process.authoring.web.ui.internal.editors.MoveDialog;
	var PracticeNavigatorData = com.ibm.team.process.authoring.web.common.internal.PracticeNavigatorData;
	var ContentEditor = com.ibm.team.process.authoring.web.ui.internal.editors.ContentEditor;
	var GeneralInputFieldEditor = com.ibm.team.process.authoring.web.ui.internal.editors.GeneralInputFieldEditor;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var PracticeTree = com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTree;
	var PracticeTreePane = com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTreePane;
	var PracticeElement = com.ibm.team.process.authoring.web.common.internal.PracticeElement;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var WorkingCopy = com.ibm.team.process.authoring.web.common.internal.WorkingCopy;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var CopyResourceLinkDialog = com.ibm.team.process.authoring.web.ui.internal.editors.CopyResourceLinkDialog;
	var CollapsibleSection = com.ibm.team.process.authoring.web.ui.internal.editors.CollapsibleSection;
	var AttachmentManager = com.ibm.team.process.authoring.web.ui.internal.editors.AttachmentManager;
	var MessageBox = jazz.ui.MessageBox;
	var LanguageJsonData = com.ibm.team.process.authoring.web.common.internal.LanguageJsonData;
	var PRACTICE_EDIT_ACTION_PREFIX = "#action=com.ibm.team.process.authoring.editPractice&resource="; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors.AbstractPracticesEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		container: null,
		leftNavigator: null,
		isNew: false,
		isGadget: false,
		rightContent: null,
		workingCopy: null,
		hasChanges: false,
		allowSave: true,
		enableLock: false,
		lockProcessing: false,
		isLockHoster: false,
		initializedContentEditor: false,
		navigateAwayHandle: null,
		onBeforeUnloadHandle: null,
		resizeNavigatorHandle: null,
		refreshAfterSave: true,
		viewOnly: false, //an associated process description is view only  
		editButton: null,
		viewButton: null,
		viewMode: true, //default mode is view mode(when opening a practice/process description) 
		titleEventHandles: [],
		sharedSupport: false, // for readShared
		canWriteShared: false, // for writeShared
		
		constructor: function(arg) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._initialize(arg);
			this.enableLock = window.location.search.toLowerCase().indexOf(ProcessAuthoringConstants.ENABLELOCK) !== -1;
		},
		
		_initialize: function(arg) {
			this.workingCopy = new WorkingCopy();
		},
		
		createPracticeTree: function() {
		},
		
		createDeatilSection: function() {
		},
		
		onRemoveSharedPractice: function(item, practiceResource, treeContainer) {
		
		},
		
		initTreePane: function() {
		
		},
		
		//====================================================================
		// UI populate
		//====================================================================
		postCreate: function() {
			if (this.isNew) {
	           	this.viewMode = false;
			}
			
			//setup message box
			this.promptMsg = new MessageBox();
			this.longPromptMsg = new MessageBox();
			this.longMessageBox.appendChild(this.longPromptMsg.domNode);
			this.messageBox.appendChild(this.promptMsg.domNode);
			
			//register navigator handler
			this.registerNavigatorHandler();
			
			//setup breadcrumbs
			this.setupBreadcrumbs();
			
			//setup command bar
			this.setupCommandBar();
			
			//setup navigation tree and content editor section
			var _self = this;
			this.container = new dijit.layout.BorderContainer({
				design: "headline", //$NON-NLS-1$
				style: "width: 100%; height: 100%;", //$NON-NLS-1$
				gutters: "true", //$NON-NLS-1$
				liveSplitters: "true" //$NON-NLS-1$
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.leftNavigator = new dijit.layout.AccordionContainer({
				region: "leading", //$NON-NLS-1$
				splitter: true, //$NON-NLS-1$
				buttonWidget: "com.ibm.team.process.authoring.web.ui.internal.editors.AuthoringAccordionButton", //$NON-NLS-1$
				style: "width: 30%; z-index: auto;" //$NON-NLS-1$
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.rightContent = new dijit.layout.ContentPane({
				region: "center", //$NON-NLS-1$
				content: "", //$NON-NLS-1$
				style: "z-index: auto;", //$NON-NLS-1$
				onLoad: function(data) {
					if (_self.isWidget(data)) {
						this.currentEditor = data;
					} else {
						this.currentEditor = null;
					}
				}
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.practiceWrapper.appendChild(this.container.domNode);
			this.container.addChild(this.leftNavigator);
			this.container.addChild(this.rightContent);
			this.initTreePane();
			this.resizeNavigatorHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_RESIZE_NAVIGATOR, this, this.resizeNavigator);
			this.container.startup();
			
			this.connect(this.domNode.parentNode, "onclick", function(e) { //$NON-NLS-1$
				if (e.target.tagName === 'A' || e.target.tagName === 'AREA') { //$NON-NLS-1$ //$NON-NLS-2$ 
					var url = e.target.href;
                    if (url) { //$NON-NLS-1$
                    	dojo.stopEvent(e);
                    	this._linkAction(url);
                    }
				}
			});
		},
		
		_connectTitleEventHandles: function() {
            var handle = this.connect(this.previewName, "onmouseover", function(e) { //$NON-NLS-1$
            	e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
            });
            this.titleEventHandles.push(handle);
            handle = this.connect(this.previewName, "onmouseout", function(e) { //$NON-NLS-1$
            	e.target.style.backgroundColor = ProcessAuthoringConstants.EMPTY;
            });
            this.titleEventHandles.push(handle);
            handle = this.connect(this.previewName, "onclick", function(e) { //$NON-NLS-1$
            	this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.EDIT);
            });
            this.titleEventHandles.push(handle);
		},

		setupBreadcrumbs: function() {
			this.breadcrumbs = new jazz.ui.Breadcrumbs();
			
			var link = {};
			link.href = this.breadcrumblink;
			link.label = this.breadcrumbText;
			link.onClick = dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
                if (this.changesPending()) {
                	if (confirm(this.messages.AbstractPracticesEditor_6)) {
						this.clearChangesPending();
                		document.location = this.breadcrumblink;
                	}
                } else {
                	document.location = this.breadcrumblink;
                }
			})
			
			this.breadcrumbs.segments = [link];
			this.breadcrumbs.refresh();
			this.breadcrumbsSite.appendChild(this.breadcrumbs.domNode);
		},
		
		createTree: function(practiceJsonData, treeContainer, hideRoot, isShared) {
			var dataStore = new dojo.data.ItemFileWriteStore({
				data: practiceJsonData
			});
			var model = new dijit.tree.ForestStoreModel({
				rootLabel: this.editPractice ? this.messages.AbstractPracticesEditor_9 : practiceJsonData.title,
				store: dataStore,
				childrenAttr: ["children"] //$NON-NLS-1$
			});
			var practiceTree = new PracticeTree({
				isOutlinePane: treeContainer.isOutlinePane,
				editPractice: treeContainer.editPractice,
				isAssociated: treeContainer.isAssociated,
				isPlainTree: treeContainer.isPlainTree,
				rootOnly: treeContainer.rootOnly,
				showRoot: !hideRoot,
				treeContainer: treeContainer,
				isSharedTree: isShared, //shared practice tree pane is view only
				viewMode: this.viewMode,
				isGadget: this.isGadget,
				model: model,
				isNew: practiceJsonData.isNew,
				canWriteShared: this.canWriteShared,
				practiceResource: practiceJsonData.resource,
				onOpenPractice: dojo.hitch(this, this.populatePracticeDescription),
				onOpenCategory: dojo.hitch(this, this.populateCategory),
				onOpenPracticeElement: dojo.hitch(this, this.populatePracticeElement),
				onNewPracticeElement: dojo.hitch(this, this.onNewPracticeElement),
				onDeletePracticeElement: dojo.hitch(this, this.onDeletePracticeElement),
				onNewNode: dojo.hitch(this, this.onNewNode),
				onDeleteNode: dojo.hitch(this, this.onDeleteNode),
				onMoveNode: dojo.hitch(this, this.onMoveNode),
				onShowMoveDialog: dojo.hitch(this, this.onShowMoveDialog),
				onDeletePractice: dojo.hitch(this, this.onDeletePractice),
				onRemoveSharedPractice: dojo.hitch(this, this.onRemoveSharedPractice),
				onNavigateSharedPractice: dojo.hitch(this, this.onNavigateSharedPractice),
				onCopyResourceUrl: dojo.hitch(this, this.onCopyResourceUrl),
				onPromotePractice: dojo.hitch(this, this.onPromotePractice),
				onExportPractice: dojo.hitch(this, this.onExportPractice)
			}, document.createElement("div")); //$NON-NLS-1$
			return practiceTree;
		},
		
		
//=======================================================================
//    action button event handling
//=======================================================================		
		onCopyResourceUrl: function(resourceUrl) {
			var text = resourceUrl; //$NON-NLS-1$
			new CopyResourceLinkDialog({
				resourceLink: text
			});
		},
		
		onExportPractice: function(resourceUrl, practiceName) {
			var url = UIHelper.getProcessAuthoringRoot() + "/file/export?uri=" + resourceUrl;//$NON-NLS-1$
			new ExportDialog({
				serviceUrl: url,
				message: dojo.string.substitute(this.messages.PracticeListPage_15, [practiceName])
			});
		},
		
		onNavigateSharedPractice: function(practiceResource) {
			if (this.changesPending()) {
				if (confirm(this.messages.AbstractPracticesEditor_6)) {
					this.navigateToPractice(practiceResource);
				}
			} else {
				this.navigateToPractice(practiceResource);
			}
		},
		
		onDeletePractice: function(item, practiceResource, treeContainer) {
			if (confirm(dojo.string.substitute(this.messages.AbstractPracticesEditor_0, [item.label]))) {
				treeContainer.removePracticeTree(practiceResource);
				this.workingCopy.deletePractice(practiceResource);
				this.setChangesPending();
				if (this.workingCopy.isParent(practiceResource, practiceResource, this.workingCopy.currentItem)) {
					this.rightContent.attr('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
					this.workingCopy.currentItem = null;
				}
			}
		},
		
	    onShowMoveDialog: function(sourceTree, sourceItem, oldParentItem) {
			if (sourceTree.treeContainer.trees.length == 1 && sourceItem.root === true) {
				alert(this.messages.AbstractPracticesEditor_11);
			} else {
				var moveDialog = new MoveDialog({
					controller: this,
					sourceTree: sourceTree,
					sourceItem: sourceItem,
					oldParentItem: oldParentItem,
					workingCopy: this.workingCopy
				});
			}
		},
		
		pasteItem: function(/*Item*/childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*int?*/ insertIndex, model) {
			// summary:
			//		Move or copy an item from one parent item to another.
			//		Used in drag & drop
			var store = model.store, parentAttr = model.childrenAttrs[0]; // name of "children" attr in parent item
			
			if (oldParentItem.root === true) {
				childItem[store._rootItemPropName] = false;
				store._arrayOfTopLevelItems.splice(dojo.indexOf(store._arrayOfTopLevelItems, childItem), 1);
				store.fetch({
					query: null,
					onComplete: dojo.hitch(model, function(newChildren) {
						model.root.children = newChildren;
						model.onChildrenChange(model.root, newChildren);
					})
				});
			}
			
			// remove child from source item, and record the attribute that child occurred in
			if (oldParentItem && oldParentItem.root !== true) {
				dojo.forEach(model.childrenAttrs, function(attr) {
					if (store.containsValue(oldParentItem, attr, childItem)) {
						var values = dojo.filter(store.getValues(oldParentItem, attr), function(x) {
							return x != childItem;
						});
						store.setValues(oldParentItem, attr, values);
						parentAttr = attr;
					}
				});
			}
			
			if (newParentItem.root === true) {
				childItem[store._rootItemPropName] = true;
				store._arrayOfTopLevelItems.splice(insertIndex, 0, childItem);
				store.fetch({
					query: null,
					onComplete: dojo.hitch(model, function(newChildren) {
						model.root.children = newChildren;
						model.onChildrenChange(model.root, newChildren);
					})
				});
			}
			
			// modify target item's children attribute to include this item
			if (newParentItem && newParentItem.root !== true) {
				if (typeof insertIndex == "number") { //$NON-NLS-1$
					var childItems = store.getValues(newParentItem, parentAttr);
					childItems.splice(insertIndex, 0, childItem);
					store.setValues(newParentItem, parentAttr, childItems);
				} else {
					store.setValues(newParentItem, parentAttr, store.getValues(newParentItem, parentAttr).concat(childItem));
				}
			}
		},
		
		onMoveNode: function(item, oldParentItem, newParentItem, position, sourceTree) { // move category and element
			// move tree node
			this.pasteItem(item, oldParentItem, newParentItem, position, sourceTree.model);
			
			// move category and element in working copy
			var node = this.workingCopy.getNodeById(item.id).node;
			var data = this.workingCopy.getNodeById(oldParentItem.id);
			var sourceParent = data.node ? data.node : data.practice;
			data = this.workingCopy.getNodeById(newParentItem.id);
			var targetParent = data.node ? data.node : data.practice;
			this.workingCopy.moveNode(node, sourceParent, targetParent, position);
			this.setChangesPending();
		},
		
		onReorderPractice: function(sourceTreeContainer, sourceResource, position) { // reorder practices
			// reorder the tree node
			var practiceId = sourceResource.substring(sourceResource.lastIndexOf("/") + 1); //$NON-NLS-1$
			var treePracticeId = null;
			var treeNode = null;
			dojo.some(sourceTreeContainer.trees, function(tree) {
				treePracticeId = tree.practiceResource.substring(tree.practiceResource.lastIndexOf("/") + 1); //$NON-NLS-1$
				if (tree.practiceResource === sourceResource || treePracticeId === practiceId) {
					treeNode = tree;
					return true;
				}
				return false;
			});
			
			var indexToDelete = dojo.indexOf(sourceTreeContainer.trees, treeNode);
			for (var i = indexToDelete + 1; i < sourceTreeContainer.trees.length; i++) {
				sourceTreeContainer.trees[i].indexInParent = sourceTreeContainer.trees[i].indexInParent - 1;
			}
			var trees = sourceTreeContainer.trees.splice(indexToDelete, 1);
			sourceTreeContainer.treeSection.removeChild(treeNode.domNode);
			treeNode.indexInParent = position;
			sourceTreeContainer.addPracticeTree(treeNode);
			
			// update working copy
			this.workingCopy.updatePracticeOrderInPracticeList(sourceResource, position);
			this.setChangesPending();
		},
		
		populatePracticeElement: function(item, practiceResource, viewOnly) {
			this.autoCommitEditor();
			
			var practiceElement = this.workingCopy.getNodeById(item.id).node;
			if (!practiceElement) {
				// item in other tree like Outline does not store resource UUID in item.id
				// do this to convert item.resource to String
				var url = item.resource + ""; //$NON-NLS-1$
				var resourceId = UIHelper.getResourceId(url);
				practiceElement = this.workingCopy.getNodeById(resourceId).node;
			}
			if (this.workingCopy.getNodeModel(practiceElement) && this.workingCopy.getNodeTextContent(practiceElement, this.workingCopy.currentLanguage)) {
				this.loadPracticeElement(item, practiceElement, viewOnly, practiceResource);
			} else if (practiceElement.status === ProcessAuthoringConstants.STATUS_NEW) {
				practiceElement.languages[this.workingCopy.currentLanguage].textContent = {};
				if (!practiceElement.languages[this.workingCopy.currentLanguage].basicInformation) {
					practiceElement.languages[this.workingCopy.currentLanguage].basicInformation = {};
				}
				practiceElement.languages[this.workingCopy.currentLanguage].basicInformation.label = ""; //$NON-NLS-1$
				practiceElement.languages[this.workingCopy.currentLanguage].basicInformation.description = ""; //$NON-NLS-1$
				this.loadPracticeElement(item, practiceElement, viewOnly, practiceResource);
			} else {
				var url = practiceElement.resource + "?lang=" + this.workingCopy.currentLanguage; //$NON-NLS-1$
				ProcessAuthoringClient.getPracticeElement({
					lastModified: this.workingCopy.lastModified,
					url: url,
					load: dojo.hitch(this, function(data, ioArgs) {
						var practiceETag = UIHelper.extractETag(ioArgs.xhr.getResponseHeader("ETag")); //$NON-NLS-1$
						if (!this.workingCopy.getNodeModel(practiceElement)) {
							var presentation = UIHelper.getPracticeElementPresentation(data);
							practiceElement.model.data = presentation;
							practiceElement.model.ETag = practiceETag.modelETag;
						}
						
						if (!this.workingCopy.getNodeTextContent(practiceElement, this.workingCopy.currentLanguage)) {
							practiceElement.languages[this.workingCopy.currentLanguage].textContent = UIHelper.getPracticeElementTextContent(data);
							practiceElement.languages[this.workingCopy.currentLanguage].ETag = practiceETag.textContentETag;
							if (!practiceElement.languages[this.workingCopy.currentLanguage].basicInformation) {
								practiceElement.languages[this.workingCopy.currentLanguage].basicInformation = {};
							}
							practiceElement.languages[this.workingCopy.currentLanguage].basicInformation.label = UIHelper.getPracticeElementTitle(data.documentElement);
							practiceElement.languages[this.workingCopy.currentLanguage].basicInformation.description = UIHelper.getPracticeElementDescription(data.documentElement);
						}
						this.loadPracticeElement(item, practiceElement, viewOnly, practiceResource);
					}),
					error: dojo.hitch(this, function(error) {
						this.displayErrorMessage(error);
					})
				});
			}
			this.workingCopy.currentItem = item.id + ''; //$NON-NLS-1$
		},
		
		addAttachmentSection: function(resource, domNode, viewOnly, contentEditor) {
			var element = this.workingCopy.getNodeById(resource).practice;
			if (element.status != ProcessAuthoringConstants.STATUS_NEW) {
				var attachmentManager = this.createAttachmentSection(resource, domNode, viewOnly, contentEditor);
				attachmentManager.refresh();
			}
		},
		
		createAttachmentSection: function(resource, domNode, viewOnly, contentEditor) {
			var attachmentSection = new CollapsibleSection({
				'title': this.messages.PracticeEditor_12, //$NON-NLS-1$
				'isExpand': false //$NON-NLS-1$
			}, domNode);
			
			//register attachment section into the content editor so that it can be released when
			// content editor is released
            if (contentEditor) {
            	contentEditor.addAttachmentSection(attachmentSection);
            }
			
			var attachmentManager = new AttachmentManager({
				'practiceResource': resource, //$NON-NLS-1$
				'viewOnly': viewOnly, //$NON-NLS-1$
				'container': this,  //$NON-NLS-1$
				'contentEditor': contentEditor //$NON-NLS-1$
			});
			
			attachmentSection.setContent(attachmentManager);
			this.connect(attachmentSection, "toggleSection", function(isExpand) { //$NON-NLS-1$
				if (isExpand) {
					attachmentSection.setTitle(this.messages.PracticeEditor_12);
				} else {
					attachmentSection.setTitle(dojo.string.substitute(this.messages.PracticeEditor_13, [attachmentManager.getCount()]));
				}
				if (contentEditor) {
					this.resizeEditor(contentEditor);
				}
			});
			
			this.connect(attachmentManager, "setCount", function(count) { //$NON-NLS-1$
				if (!attachmentSection.isExpand) {
					attachmentSection.setTitle(dojo.string.substitute(this.messages.PracticeEditor_13, [attachmentManager.getCount()]));
				}
			});
			
			return attachmentManager;
		},
		
		populatePracticeDescription: function(item, practiceResource, viewOnly) {
			this.autoCommitEditor();
			
			var practiceNode = this.workingCopy.getPractice(practiceResource.toString());
			var currentLanguage = this.workingCopy.currentLanguage;
			var currentLanguageData = practiceNode.languages[currentLanguage];
			if (currentLanguageData && currentLanguageData.isDescriptionLoaded || practiceNode.status === ProcessAuthoringConstants.STATUS_NEW) {
				this.loadPractice(item, practiceNode, viewOnly);
			} else {
				ProcessAuthoringClient.getPractice({
					'lastModified': this.workingCopy.lastModified, //$NON-NLS-1$
					'url': practiceNode.resource + "?lang=" + currentLanguage + "&view=description", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
						var practiceETag = UIHelper.extractETag(ioArgs.xhr.getResponseHeader("ETag")); //$NON-NLS-1$
						if (!currentLanguageData) {
							practiceNode.languages[currentLanguage] = {};
						}
						practiceNode.languages[currentLanguage].isDescriptionLoaded = true;
						if (!this.workingCopy.getNodeModel(practiceNode)) {
							var presentation = UIHelper.getPracticeElementPresentation(data);
							practiceNode.model.data = presentation;
							practiceNode.model.ETag = practiceETag.modelETag;
						}
						
						practiceNode.languages[this.workingCopy.currentLanguage].textContent = UIHelper.getPracticeElementTextContent(data);
						practiceNode.languages[this.workingCopy.currentLanguage].ETag = practiceETag.textContentETag;
						if (!practiceNode.languages[this.workingCopy.currentLanguage].basicInformation) {
							practiceNode.languages[this.workingCopy.currentLanguage].basicInformation = {};
						}
						practiceNode.languages[this.workingCopy.currentLanguage].basicInformation.label = UIHelper.getPracticeElementTitle(data.documentElement);
						practiceNode.languages[this.workingCopy.currentLanguage].basicInformation.description = UIHelper.getPracticeElementDescription(data.documentElement);
						this.loadPractice(item, practiceNode, viewOnly);
					}),
					'error': dojo.hitch(this, function(error) { //$NON-NLS-1$
						this.displayErrorMessage(error);
					})
				});
			}
		},
		
		loadPractice: function(item, practice, viewOnly) {
			var practiceXML = UIHelper.getPracticeElementXML(practice, this.workingCopy.currentLanguage, true);
			
			var contentEditor = new ContentEditor({
				item: item,
				editPractice: this.editPractice,
				controller: this,
				practiceResource: practice.resource,
				practiceElementData: practiceXML.documentElement,
				viewOnly: viewOnly,
				workingCopy: this.workingCopy,
				onChange: dojo.hitch(this, function(practiceResource, data) {
					this.workingCopy.updatePractice(practiceResource, data);
					this.setChangesPending();
				})
			});
			
			if (!this.editPractice) {
				this.addAttachmentSection(practice.resource, contentEditor.additionalContent, viewOnly, contentEditor);
			} else {
				dojo.style(contentEditor.descriptionArea.detailEditor, "display", "none"); //$NON-NLS-2$ //$NON-NLS-1$
			}
			contentEditor.addInitializedCallback(dojo.hitch(this, function() {
				this.workingCopy.currentItem = item.id + ''; //$NON-NLS-1$
				this.rightContent.attr('content', contentEditor); //$NON-NLS-1$
				this.resizeEditor(contentEditor);
			}));
		},
		
		onNewNode: function(item, practiceResource) {
			this.autoCommitEditor();
			
			var f = dojo.hitch(this, function(groupingName) {
				var uuid = dojox.uuid.generateTimeBasedUuid();
				var newCategory = null;
				if (item.root) {
					newCategory = item.store.store.newItem({
						id: uuid,
						label: groupingName,
						type: ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY,
						children: []
					}, {
						parent: item
					});
				} else {
					newCategory = item._S.newItem({
						id: uuid,
						label: groupingName,
						type: ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY,
						children: []
					}, {
						parent: item,
						attribute: "children" //$NON-NLS-1$
					});
				}
				this.workingCopy.addCategory(practiceResource, item.id, uuid, groupingName);

				var categoryEditor = new GeneralInputFieldEditor({
					controller: this,
					viewOnly: false,					
					item: newCategory,
					practiceResource: practiceResource,					
					field: newCategory.label,
					onCategoryChange: dojo.hitch(this, this.onCategoryChange)
				});
				
				categoryEditor.addInitializedCallback(dojo.hitch(this, function() {
					this.rightContent.attr('content', categoryEditor); //$NON-NLS-1$
					this.resizeEditor(categoryEditor);
				}));
				
				this.setChangesPending();
				this.workingCopy.currentItem = uuid;
			});
			
			f(this.messages.AbstractPracticesEditor_1);
		},
		
		onAddPractice: function(treePane) {
			this.autoCommitEditor();
			
			var f = dojo.hitch(this, function(practiceName) {
				var practiceJsonData = PracticeNavigatorData.getEmptyPracticeJsonData(practiceName, '', this.processDescriptionId, this.workingCopy.currentLanguage); //$NON-NLS-1$
				this.workingCopy.createPractice(dojo.clone(practiceJsonData));
				var tree = this.createTree(practiceJsonData, treePane, false, false);
				tree.indexInParent = treePane.trees.length;
				treePane.addPracticeTree(tree);
				treePane.selectTree(tree);
				this.setChangesPending();

				var contentEditor = new ContentEditor({
					controller: this,
					editPractice: this.editPractice,
					isNewNode: true,
					item: tree.model.root,
					workingCopy: this.workingCopy,
					practiceResource: practiceJsonData.resource,
					practiceElementLanguage: this.workingCopy.currentLanguage,
					onChange: dojo.hitch(this, function(practiceResource, data) {
						this.workingCopy.updatePractice(practiceResource, data);
						this.setChangesPending();
					})
				});
				
				contentEditor.addInitializedCallback(dojo.hitch(this, function() {
					this.rightContent.attr('content', contentEditor); //$NON-NLS-1$
					this.resizeEditor(contentEditor);
				}));
				
				this.workingCopy.currentItem = practiceJsonData.id + '';//$NON-NLS-1$
			});
			
			f(this.messages.AbstractPracticesEditor_2);
		},
		
		onNewPracticeElement: function(item, practiceResource) {
			this.autoCommitEditor();
			
			var newItem = null;
			var uuid = dojox.uuid.generateTimeBasedUuid();
			
			if (item.root) {
				newItem = item.store.store.newItem({
					id: uuid,
					label: this.messages.AbstractPracticesEditor_3,
					type: ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT,
					resource: null
				}, {
					parent: item
				});
			} else {
				newItem = item._S.newItem({
					id: uuid,
					label: this.messages.AbstractPracticesEditor_3,
					type: ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT,
					resource: null
				}, {
					parent: item,
					attribute: "children" //$NON-NLS-1$
				});
			}
			
			var contentEditor = new ContentEditor({
				isNewNode: true,
				controller: this,
				practiceResource: practiceResource,	
				item: newItem,
				workingCopy: this.workingCopy,
				practiceElementLanguage: this.workingCopy.currentLanguage,
				onChange: dojo.hitch(this, function(item, data) {
					this.workingCopy.updatePracticeElement(item.id, data);
				})
			});
			
			contentEditor.addInitializedCallback(dojo.hitch(this, function() {
				this.rightContent.attr('content', contentEditor); //$NON-NLS-1$
				this.resizeEditor(contentEditor);
			}));
			
			this.workingCopy.addPracticeElement(practiceResource, item.id, uuid, contentEditor.getXML());
			this.setChangesPending();
			this.workingCopy.currentItem = uuid;
		},
		
		onDeleteNode: function(item, practiceResource) {
			if (confirm(dojo.string.substitute(this.messages.AbstractPracticesEditor_4, [item.label]))) {
				if (item.root) {
					item.store.store.deleteItem(item);
				} else {
					item._S.deleteItem(item);
				}
				this.workingCopy.deleteCategory(item.id);
				this.setChangesPending();
				
				if (this.workingCopy.isParent(practiceResource, item.id, this.workingCopy.currentItem)) {
					this.rightContent.attr('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
					this.workingCopy.currentItem = null;
				}
			}
		},
		
		onDeletePracticeElement: function(item, practiceResource) {
			if (confirm(dojo.string.substitute(this.messages.AbstractPracticesEditor_5, [item.label]))) {
				item._S.deleteItem(item);
				this.workingCopy.deletePracticeElement(item.id);
				this.setChangesPending();
				if (this.workingCopy.currentItem == item.id) {
					this.rightContent.attr('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
					this.workingCopy.currentItem = null;
				}
			}
		},
		
		onPracticeChange: function(title, description, practiceResource) {
			this.workingCopy.updatePracticeSummary(title, description, practiceResource);
			this.setChangesPending();
		},
		
		autoCommitEditor: function() {
			if (this.rightContent.currentEditor && dojo.isFunction(this.rightContent.currentEditor.doCommit)) {
				this.rightContent.currentEditor.doCommit();
			}
		},
		
		populateCategory: function(item, practiceResource, viewOnly) {
			this.autoCommitEditor();

			var categoryEditor = new GeneralInputFieldEditor({
				controller: this,
				viewOnly: viewOnly,
				item: item,
				practiceResource: practiceResource,
				field: item.label,
				onCategoryChange: dojo.hitch(this, this.onCategoryChange)
			});
			categoryEditor.isViewOnly();
			
			categoryEditor.addInitializedCallback(dojo.hitch(this, function() {
				this.rightContent.attr('content', categoryEditor); //$NON-NLS-1$
				this.resizeEditor(categoryEditor);
			}));
			
			this.workingCopy.currentItem = item.id + '';//$NON-NLS-1$
		},
		
		onCategoryChange: function(item) {
			this.workingCopy.updateCategory(item.id, item.label);
			this.setChangesPending();
		},
		
		getPracticeURL: function(practiceResource) {
			var practiceURL;
			if (this.workingCopy.getPractice(practiceResource).status == ProcessAuthoringConstants.STATUS_NEW) {
				practiceURL = null;
			} else {
				practiceURL = practiceResource;
			}
			return practiceURL;
		},
		
		loadPracticeElement: function(item, practiceElement, viewOnly, practiceResource) {
			var practiceElementXML = UIHelper.getPracticeElementXML(practiceElement, this.workingCopy.currentLanguage);

			var contentEditor = new ContentEditor({
				item: item,
				controller: this,
				practiceElementData: practiceElementXML.documentElement,
				viewOnly: viewOnly,
				workingCopy: this.workingCopy,
				practiceResource: practiceResource,
				onChange: dojo.hitch(this, function(item, data) {
					this.workingCopy.updatePracticeElement(item.id, data);
					this.setChangesPending();
				})
			});

			contentEditor.addInitializedCallback(dojo.hitch(this, function() {
				this.rightContent.attr('content', contentEditor); //$NON-NLS-1$
				this.resizeEditor(contentEditor);
			}));
		},
		
		
		openCurrentItem: function(treePane, shared) {
			var node = null;
			if (this.workingCopy.currentItem && !this.initializedContentEditor) {
				node = this.workingCopy.getNodeById(this.workingCopy.currentItem);
				if (node.node) {
					treePane.getItem(node.practice.resource, node.node, dojo.hitch(this, function(item, tree) {
						this.initializedContentEditor = true;
						if (node.node.type == ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
							this.populateCategory(item, node.practice.resource, shared);
						} else if (node.node.type == ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT) {
							this.populatePracticeElement(item, node.practice.resource, shared);
						}
						treePane.selectTree(tree);
						var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
						tree.attr("path", path); //$NON-NLS-1$
					}));
				} else if (node.practice) {
					treePane.getItem(node.practice.resource, null, dojo.hitch(this, function(item, tree) {
						this.initializedContentEditor = true;
						this.populatePracticeDescription(item, node.practice.resource, shared);
						treePane.selectTree(tree);
						var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
						tree.attr("selectedItem", path[0]); //$NON-NLS-1$
					}));
				}
			}
		},
		
		toggleViewEditMode: function(e) {
			dojo.stopEvent(e);
			if ( !this.viewMode ) {
				this.autoCommitEditor();
			}
            this.viewMode = !this.viewMode;
			this._toggleViewEditMode();
		},
		
		_toggleViewEditMode: function() {
			if (this.viewMode) {
				dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, []); //$NON-NLS-1$
			} else {
				dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, []); //$NON-NLS-1$
			}
			
			dojo.toggleClass(this.previewName,"NoCursorPreviewField", this.viewMode);			 //$NON-NLS-1$
			
			//disconnect/connect event for title field
            if (this.viewMode) {
            	dojo.forEach(this.titleEventHandles, function(handle) {
            		this.disconnect(handle);
            	}, this);
            	this.titleEventHandles = [];
            } else {
				this._connectTitleEventHandles();
			}
		},
		
		//==============================================================================================
		//  Save/refresh handling
		//==============================================================================================
		getResult: function(results) {
			jazz.ui.underlay.hide();
			var success = true;
			for (var i = 0; i < results.length; i++) {
				var result = results[i];
				if (!result.success) {
					//there're errors, now just display the first error.
					success = false;
					this.displayErrorMessage(result);
					break;
				}
			}
			
			if (success && this.refreshAfterSave) {
				this.clearChangesPending();
				this.refresh();
			}
			if (this.updateDoneHandle) {
				dojo.unsubscribe(this.updateDoneHandle);
				this.updateDoneHandle = null;
			}
			return success;
		},
		
		doSave: function() {
			jazz.ui.underlay.show();
			this.updateDoneHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_UPDATEDONE, this, this.getResult);
			this.workingCopy.executeUpdate();
		},
		
		refresh: function() {
			this.registerNavigatorHandler();
			this.clearChangesPending();
			this.initializedContentEditor = false;
			this.rightContent.attr('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		//===============================================
		//           navigator handling
		//===============================================
		registerNavigatorHandler: function() {
			if (!this.navigateAwayHandle && !this.isGadget) {
				this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10001);
				this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
			}
		},
		
		_handleNavigate: function(urlObj) {
			if (this.changesPending()) {
				if (!confirm(this.messages.AbstractPracticesEditor_6)) {
					return true; //veto the navigate
				}
			}
			//move away from the editor
			this._unregisterHandlers();
			return false;
		},
		
		navigateAwayEvent: function() {
			return this.changesPending() ? this.messages.AbstractPracticesEditor_7 : false;
		},
		
		_unregisterHandlers: function() {
			if (!this.isGadget) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
				this.navigateAwayHandle = null;
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
				this.onBeforeUnloadHandle = null;
			}
		},
		
		//================================================================================
		//          Dirty handling
		//================================================================================
		setChangesPending: function() {
			this.hasChanges = true;
			this.setDirty();
		},
		changesPending: function() {
			return this.hasChanges;
		},
		
		toggleDirty: function(isDirty) {
			if (!this.name.value) {
				dojo.attr(this.saveButton, 'disabled', true); //$NON-NLS-1$
			} else {
				dojo.attr(this.saveButton, 'disabled', !isDirty); //$NON-NLS-1$
			}
			dojo.toggleClass(this.modifiedFlag, "hide", !this.hasChanges); //$NON-NLS-1$
			if (isDirty) {
				this._clearMessage();
			}
		},
		
		_handleLock: function(lockRequest, byForce, updatePractice) {
			ProcessAuthoringClient.handleLock({
				byForce: byForce,
				updatePractice: updatePractice,
				lockRequest: lockRequest,
				itemId: this.getResourceID(),
				ETag: this.getModelETag(),
				load: dojo.hitch(this, function(data, ioArgs) {
					this.lockProcessing = false;
					this.setETag(ioArgs.xhr.getResponseHeader("ETag")); //$NON-NLS-1$
					this.toggleDirty(lockRequest);
					this.isLockHoster = lockRequest; //lockRequest=true is for lock request, lockRequest=false is for lock release
				}),
				error: dojo.hitch(this, function(error) {
					this.lockProcessing = false;
					if (lockRequest && error.status === ProcessAuthoringConstants.SC_LOCKED) {
						var jsonResponse = dojo.fromJson(error.responseText);
						if (confirm(dojo.string.substitute(this.messages.AbstractPracticesEditor_8, [jsonResponse[ProcessAuthoringConstants.LOCKEDBY_TAG]]))) {
							this.toggleDirty(lockRequest);
							this.handleLock(lockRequest, true);
						} else {
							this.refresh();
						}
					} else {
						this.displayErrorMessage(error);
					}
				})
			});
		},
		
		setDirty: function(toggleField) {
			var isDirty = (this.hasChanges && this.allowSave);
			
			var needHandle = ((isDirty && !this.isLockHoster) || (!isDirty && this.isLockHoster)) && (toggleField !== 'undefined' && !toggleField); //$NON-NLS-1$ //$NON-NLS-2$
			if (this.enableLock && !this.isNew && needHandle) { //don't need to have a lock for creating a new resource 
				if (!this.lockProcessing) { //avoid duplicated requests before getting the response
					this.lockProcessing = true;
					this.handleLock(isDirty, false);
				}
			} else {
				this.toggleDirty(isDirty);
			}
		},
		
		canSave: function() {
			return this.allowSave;
		},
		
		setCanSave: function() {
			this.allowSave = true;
			this.setDirty(true);
		},
		
		clearCanSave: function() {
			this.allowSave = false;
			this.setDirty(true);
		},
		
		clearChangesPending: function() {
			this.hasChanges = false;
			this.setDirty();
		},
		
		//=========================================================
		//         handle messages
		//=========================================================
		_clearMessage: function() {
			this.promptMsg.hideMessage();
			this.longPromptMsg.hideMessage();
		},
		
		displayMessage: function(msg, cssClass) {
			if (cssClass === ProcessAuthoringConstants.EMPTY && msg === ProcessAuthoringConstants.EMPTY) {
				this._clearMessage();
			} else {
				this.longPromptMsg.hideMessage();
				this.promptMsg.showMessage({
					type: cssClass,
					summary: msg
				});
			}
		},
		
		displayLongMessage: function(msg, cssClass, closable) {
			if (cssClass === ProcessAuthoringConstants.EMPTY && msg === ProcessAuthoringConstants.EMPTY) {
				this._clearMessage();
			} else {
                this.promptMsg.hideMessage();
                if (msg instanceof Error || typeof msg === "object") { //$NON-NLS-1$
                	this.longPromptMsg.showMessage({
						type: cssClass,
						summary: msg.headerMessage,
						errorObject: msg,
						closable: closable
					});
                } else {
                	this.longPromptMsg.showMessage({
                		type: cssClass,
                		summary: msg,
						closable: closable
                	});
                }
			}
		},
		
		
		displaySuccessMessage: function(msg) {
			this.displayLongMessage(msg, "OK"); //$NON-NLS-1$
		},
		
		displayErrorMessage: function(msg) {
			this.displayLongMessage(msg, "ERROR"); //$NON-NLS-1$
		},
		
		displayWarningMessage: function(msg, closable) {
			this.displayLongMessage(msg, "WARNING", closable); //$NON-NLS-1$
		},
		
		displayWaitingMessage: function(msg) {
			this.displayMessage(msg, "INFO"); //$NON-NLS-1$
		},
		
		/**
		 * 
		 * @param {Object} error
		 * @param {Object} ioArgs
		 * @param {boolean} missingLicenseAsWarning if true, the error will be reported as a warning. This parameter is optional, default value is false
		 */
		_handleResponseError: function(error, ioArgs, missingLicenseAsWarning) {
			if (error.responseText) {
				error.message = error.responseText;
			}
			var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
			var msgType;
			if (licenseWarning) {
				error.headerMessage = licenseWarning;
			}
			if(missingLicenseAsWarning && licenseWarning) {
				msgType = "WARNING"; //$NON-NLS-1$
			} else {
				msgType = "ERROR"; //$NON-NLS-1$
			}
			error.errorObject = error;
			this.displayLongMessage(error, msgType);
		},		
		
		//================================================================================
		// other helper function
		//================================================================================
		isWidget: function(it) {
			if (it && dojo.isObject(it) && it.domNode) {
				return true;
			} else {
				return false;
			}
		},

		resizeEditor: function(editor) {
            if (editor) {
            	var height_em;
            	height_em = editor.domNode.clientHeight / 12;
            	if (height_em > 33) {
            		this.practiceWrapper.style.height = (height_em + 4 * (editor.domNode.clientHeight / 500)) + "em"; //$NON-NLS-1$
            	} else {
            		this.practiceWrapper.style.height = "33em"; //$NON-NLS-1$
            	}
            }
			this.container.resize();
			if (this.isGadget) {
				gadgets.window.adjustHeight();
			}
		},

		navigateToPractice: function(practiceResource) {
			window.location.replace(PRACTICE_EDIT_ACTION_PREFIX + practiceResource);
		},

		convertXMLtoJsonData: function(xmlData, ETag) {
			var navigatorData = new PracticeNavigatorData({
				practiceXMLData: xmlData,
				ETag: ETag
			});
			return navigatorData.getJsonData();
		},
		
		getFullLanguage: function(lang) {
			if (!this.workingCopy.languageList) {
				this.workingCopy.languageList = this.getLanguageJsonObj().items;
			}
			var langDesc = null;
			if (this.workingCopy.languageList != undefined) {
				dojo.some(this.workingCopy.languageList, function(language) {
					if (language.langCode === lang) {
						langDesc = language.label;
						return true;
					}
					return false;
				}, this);
			}
			if (langDesc == null) {
				langDesc = lang;
			}
			return langDesc;
		},
		
		resizeNavigator: function(addWidth) {
			var newNavigatorWidth = this.leftNavigator.domNode.offsetWidth + addWidth;
			this.leftNavigator.domNode.style.width = newNavigatorWidth+"px"; //$NON-NLS-1$
            
			//gadget's width can't be adjust dynamically, so for gadget, don't adjust the wrapper width
            if (!this.isGadget) {
            	this.practiceWrapper.style.width = this.practiceWrapper.clientWidth + addWidth + "px"; //$NON-NLS-1$
            }
           	this.container.resize();
		},
		
		getLanguageJsonObj: function() {
			return LanguageJsonData.getLanguageJsonData();
		},
		
		uninitialize: function() {
			if (this.promptMsg) {
				this.promptMsg.destroyRecursive();
			}
			
			if (this.longPromptMsg) {
				this.longPromptMsg.destroyRecursive();
			}
			
			this.container.destroyRecursive();
			if (this.updateDoneHandle) {
				dojo.unsubscribe(this.updateDoneHandle);
				this.updateDoneHandle = null;
			}
			
			if ( this.resizeNavigatorHandle ) {
				dojo.unsubscribe(this.resizeNavigatorHandle);
				this.resizeNavigatorHandle = null;	
			}
			
			if (this.breadcrumbs) {
				this.breadcrumbs.destroyRecursive();
				delete this.breadcrumbs;
			}
			this.inherited(arguments);
		}
	});
})();
