/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessAuthoringResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
(function() {
	var ResourceLink = jazz.ui.ResourceLink;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var processAuthoringMessages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessAuthoringResourceLink", ResourceLink, { //$NON-NLS-1$
		uuid: null,
		
		postCreate: function() {
			if (this.iconNode) {
				this.iconNode = dojo.byId(this.iconNode);
			}
			
			if (this.lazyFetch || (defaultLazyFetch && this.lazyFetch !== false)) {
				this.lazyFetch = true;
			} else {
				this._registerWithAggregator(this._batchedPresentationHandler, this._errorPresentation);
			}
			
			this.popup = new com.ibm.team.process.authoring.web.ui.internal.editors._RichHover({
				around: this.domNode,
				uri: this.uri,
				uuid: this.uuid,
				presentationUri: this.presentationUri,
				lazyFetch: this.lazyFetch,
				onDisable: dojo.hitch(this, this._disable)
			});
		}
	});
	
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors._RichHover", net.jazz.ui._RichHover, { //$NON-NLS-1$
		discardNode: null,
		uuid: null,
		removedResourceLink: null,
		
		discardResource: function(e) {
			dojo.stopEvent(e);
			
			if (this.removedResourceLink) {
				ProcessAuthoringClient.deleteLink({
					removedProcessDescriptionLink: this.removedResourceLink,
					load: dojo.hitch(this, function(data) {
						this._presentation.bottomSection.removeChild(this.discardNode);
						this.discardNode = null;
						this.close();
					}),
					error: dojo.hitch(this, function(error) {
						this.close();
					})
				});
			}
		},
		
		_createPresentation: function(node) {
			var retNode = this.inherited(arguments);
			this.uri = null;
			this._fetchProcessDescriptionLinks();
			return retNode;
		},
		
		_fetchProcessDescriptionLinks: function() {
			var deferred = ProcessAuthoringClient.getLinks({
				targetUrl: UIHelper.getURLPrefix() + "/process/project-areas/" + this.uuid, //$NON-NLS-1$
				load: dojo.hitch(this, function(data) {
					var strPreview = "smallPreview"; //$NON-NLS-1$
					if (this.compactRendering.largePreview) {
						strPreview = "largePreview"; //$NON-NLS-1$
					}
					
					if (data) {
						var rdfNode = data.documentElement;
						var linkChildren = rdfNode.childNodes;
						var links = UIHelper.getNodes(linkChildren, "Link", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
						var count = links.length;
						if (count > 0) {
							var processDescriptionLink = links[0];
							var titleNode = UIHelper.getNode(processDescriptionLink.childNodes, "sourceTitle", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
							var sourceNode = UIHelper.getNode(processDescriptionLink.childNodes, "source", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
							var attributeNode = UIHelper.getAttributeNode(sourceNode, "resource", ProcessAuthoringConstants.NAMESPACE_RDF); //$NON-NLS-1$
							var sourceUrl = attributeNode.value;
							
							this.removedResourceLink = {
								linkUrl: UIHelper.getAttributeNode(processDescriptionLink, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF).value,
								name: titleNode.firstChild.data,
								resourceUrl: sourceUrl
							};
							if (!this.discardNode && this.removedResourceLink) {
								this.discardNode = document.createElement("a"); //$NON-NLS-1$
								dojo.attr(this.discardNode, "href", "#"); //$NON-NLS-1$ //$NON-NLS-2$
								dojo.attr(this.discardNode, "style", "float: right"); //$NON-NLS-1$ //$NON-NLS-2$
								this.discardNode.innerHTML = processAuthoringMessages.ProcessAuthoringResourceLink_0;
								dojo.addClass(this.discardNode, "secondaryLink"); //$NON-NLS-1$
								this.connect(this.discardNode, "onclick", this.discardResource); //$NON-NLS-1$
								this._presentation.bottomSection.appendChild(this.discardNode);
								//sample: https://localhost:9443/jazz/process-authoring/descriptions/_P7viQFNJEd-CepC4-3V0aA?preview=smallPreview
							}
							
							this._presentation.hoverIframe.src = this.removedResourceLink.resourceUrl + "?preview=" + strPreview; //$NON-NLS-1$
							this._presentation.titleLink.innerHTML = this.removedResourceLink.name;
							if (this.removedResourceLink.resourceUrl.indexOf("descriptions") === -1) { //practice and practice elements //$NON-NLS-1$
								this._presentation.titleLink.href = "#action=com.ibm.team.process.authoring.editPractice&resource=" + this.removedResourceLink.resourceUrl; //$NON-NLS-1$
							} else {
								this._presentation.titleLink.href = "#action=com.ibm.team.process.authoring.editProcessDescription&resource=" + this.removedResourceLink.resourceUrl; //$NON-NLS-1$
							}
							
						} else {
							//sample: https://localhost:9443/jazz/process-authoring/links?resource=https://localhost:9443/jazz/process/project-areas/_nIWLwFNJEd-CepC4-3V0aA&amp;preview=smallPreview
							this._presentation.hoverIframe.src = UIHelper.getFullProcessAuthoringRoot() + "/links?resource=" + UIHelper.getURLPrefix() + "/process/project-areas/" + this.uuid + "&preview=" + strPreview; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
							this._presentation.titleLink.href = "#"; //$NON-NLS-1$
							this._presentation.titleLink.innerHTML = ""; //$NON-NLS-1$
						}
					}
				}),
				error: dojo.hitch(this, function(error) {
					console.log(error);
				})
			});
		}
	});
})();


