/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditor"); //$NON-NLS-1$
	dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("dijit.layout.AccordionContainer"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.AbstractPracticesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionDetailEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTreePane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.SharedPracticeSelectionDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionLanguageDialog"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.PracticeElement"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.NavigationData"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	 
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient;
	var ProcessDescriptionDetailEditor = com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionDetailEditor;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var PracticeTreePane = com.ibm.team.process.authoring.web.ui.internal.editors.PracticeTreePane;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var SharedPracticeSelectionDialog = com.ibm.team.process.authoring.web.ui.internal.editors.SharedPracticeSelectionDialog;
	var ProcessDescriptionLanguageDialog = com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionLanguageDialog;
	var PracticeElement = com.ibm.team.process.authoring.web.common.internal.PracticeElement;
	var ImportDialog = com.ibm.team.process.authoring.web.ui.internal.dialogs.ImportDialog;
	var ExportDialog = com.ibm.team.process.authoring.web.ui.internal.dialogs.ExportDialog;
	var NavigationData = com.ibm.team.process.authoring.web.common.internal.NavigationData;
	
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditor", [com.ibm.team.process.authoring.web.ui.internal.editors.AbstractPracticesEditor], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web", "ui/internal/editors/templates/ProcessDescriptionEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		outlinePane: null,
		practicePane: null,
		resourceURL: null,
		processDescriptionId: null,
		processDescriptionName: null,
		processDescriptionLanguage: null,
		processDescriptionOwner: null,
		processDescriptionOwnerName: null,
		processDescription: "", //$NON-NLS-1$
		processDescriptionXML: null,
		processDescriptionETag: null,
		detailEditor: null,
		isShared: false,
		isPLMShared: false,
		breadcrumblink: "#action=com.ibm.team.process.authoring.manageProcessDescriptions", //$NON-NLS-1$
		//constants definition
		TITLE_LABEL: "name", //$NON-NLS-1$
		OWNER_LABEL: "owner", //$NON-NLS-1$
		PLMSHARED_TARGET: "IsPLMShared", //$NON-NLS-1$
		
		DEFAULT_PROCESSDESCRIPTION_OWNERURL: UIHelper.getURLPrefix() + "/process/project-areas/[PROJECTAREA-UUID]", //$NON-NLS-1$
		_initialize: function(arg) {
			this.breadcrumbText = this.messages.ProcessDescriptionEditor_4;
			this.inherited(arguments);
			this.enableLock = window.location.search.toLowerCase().indexOf(ProcessAuthoringConstants.ENABLELOCK) !== -1;
			
			if (arg.resource) {
				this.resourceURL = arg.resource;
				if(arg.practiceId){
					this.practiceId = arg.practiceId;
				}
				if(arg.practiceElementId){
					this.practiceElementId = arg.practiceElementId;
				}
			} else {
				if (arg.ownerURL) {
					this.processDescriptionOwner = arg.ownerURL; //$NON-NLS-1$
				}
				this.isNew = true;
			}
			
			this._processDescriptionIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/process_description_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
            this._exportIconSrc = "com.ibm.team.process.authoring.web/graphics/icons/export-process-description_co.gif"; //$NON-NLS-1$
            this._editModeIconSrc = "com.ibm.team.process.authoring.web/graphics/icons/edit-button.gif"; //$NON-NLS-1$
            this._copyUrlIconSrc = "com.ibm.team.process.authoring.web/graphics/icons/copyurl-button.gif"; //$NON-NLS-1$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			this.isFirstLoad = true;
			if (this.viewOnly) {
				dojo.addClass(this.name, "hide"); //$NON-NLS-1$
			} else {
				//for primary field toggling
				this._connectTitleEventHandles();				
				this.connect(this.name, "onblur", function(e) { //$NON-NLS-1$
					this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.PREVIEW);
				});
				
				this.connect(this.name, "onkeyup", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.name, "onchange", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				
				this.editButton._setPressedAttr(!this.viewMode);
			}
			
			//this must be called after layout			
            if (this.isNew) {
            	this._hidePracticeTree();
				this.detailEditor.onSize = dojo.hitch(this, this.resizeEditor);
            	this._toggleHiddenButtons(true) //hide export button
            } else {
				this._toggleViewEditMode();				
			}
		},
		
		_toggleViewEditMode: function() {
			this.inherited(arguments);
			//in edit mode, disable the outline structure
            if (!this.viewMode && this.outlinePane && !this.outlinePane.disabled) {
            	this.outlinePane.disabled = true;
            	var node = this.processDescriptionTreePane.trees[0].getNodesByItem(this.workingCopy.currentItem);
            	if (node && node[0]) {
            		var isOutlineElement = node[0].item.root ? node[0].item.isOutlineElement : node[0].item._S.getValue(node[0].item, "isOutlineElement"); //$NON-NLS-1$
            	}

				//current element is an element in the outline pane
                if (this.rightContent.currentEditor && isOutlineElement) {
                	var url = node[0].item._S.getValue(node[0].item, "resource"); //$NON-NLS-1$
                	//it's a practice or practice element
                	if (url) {
						if (UIHelper.isPracticeURL(url)) {
							this.workingCopy.currentItem = url;
						} else {
							this.workingCopy.currentItem = url.substring(url.lastIndexOf("/") + 1); //$NON-NLS-1$
						}
                		this._linkAction(url);
                	} else { //category doesn't have url
                		this.leftNavigator.selectChild(this.practicePane);
                	}
                } else {
                	this.leftNavigator.selectChild(this.practicePane);
                }
            } else if (this.viewMode && this.outlinePane) {
            	this.outlinePane.disabled = false;
            }
			
			//toggle view/edit mode in practiceTreePane, target mode is view, hide the action buttons
            if (this.editToolBar_AddPrivatePractice) {
            	dojo.toggleClass(this.editToolBar_AddPrivatePractice.domNode, ProcessAuthoringConstants.CSS_HIDE, this.viewMode);
			}
			
            if (this.editToolBar_AddSharedPractice) {
            	dojo.toggleClass(this.editToolBar_AddSharedPractice.domNode, ProcessAuthoringConstants.CSS_HIDE, this.viewMode);
            }
		},
		
		_toggleHiddenButtons: function(isHide) {
			if (this.copyUrlButton) {
				dojo.toggleClass(this.copyUrlButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
			if (this.exportProcessDescriptionButton) {
				dojo.toggleClass(this.exportProcessDescriptionButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
		},
		
		_linkAction: function(url) {
			var resourceId = url.substring(url.lastIndexOf("/") + 1); //$NON-NLS-1$
			var isInPracticePane = false;
			if (UIHelper.isPracticeURL(url)) { //practices
				if (this.practiceTreePane) {
					this.practiceTreePane.getItem(url, null, dojo.hitch(this, function(item, tree) {
						this.populatePracticeDescription(item, url, tree.viewOnly); //$NON-NLS-1$
						this.practiceTreePane.selectTree(tree);
						var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
						tree.attr("selectedItem", path[0]); //$NON-NLS-1$
						setTimeout(dojo.hitch(this, function() {
		            		tree.attr("selectedItem", path[0]); //$NON-NLS-1$
		            	}), 500);
						isInPracticePane = true;
					}));
				}
				if (!isInPracticePane) {
					//go to Fronting app
					if (this.isGadget) {
						if (window.top) {
							window.top.location.replace(url);
						}
					} else {
						window.location.replace(url);
					}
				}
			} else if (UIHelper.isPracticeElementURL(url)) { //practice elements
				if (this.practiceTreePane) {
					dojo.some(this.practiceTreePane.trees, function(tree) {
						if (resourceId) {
							tree.model.store.fetchItemByIdentity({
								identity: resourceId,
								onItem: dojo.hitch(this, function(item) {
									if (item) {
										this.populatePracticeElement(item, url, tree.viewOnly);
										this.practiceTreePane.selectTree(tree);
										var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
										setTimeout(dojo.hitch(this, function() {
						            		tree.attr("path", path); //$NON-NLS-1$
						            	}), 500);
										isInPracticePane = true;
										return true;
									}
								})
							});
						}
						return false;
					}, this);
				}
				if (!isInPracticePane) {
					//go to Fronting app
					if (this.isGadget) {
						if (window.top) {
							window.top.location.replace(url);
						}
					} else {
						window.location.replace(url);
					}
				}
			} else if (UIHelper.isProcessDescriptionURL(url)) { //descriptions
				//go to Fronting app
				if (this.isGadget) {
					if (window.top) {
						window.top.location.replace(url);
					}
				} else {
					if (url !== this.resourceURL) {
						window.location.replace(url);
					} else {
						if (confirm(this.messages.ProcessDescriptionEditor_22)) {
							window.location.replace(url);
						}
					}
				}
			} else {
                if (this.isGadget) {
                	if (window.top) {
                		window.top.location.replace(url);
                	}
                } else {
                	window.location.replace(url);
                }
			}
			
            
            if (isInPracticePane) {
            	this.leftNavigator.selectChild(this.practicePane);
            	setTimeout(dojo.hitch(this, function() {
            		this.container.resize();
            	}), 200);
            }
			
			return false;
		},
		
		exportProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			var url = UIHelper.getProcessAuthoringRoot() + "/file/export?uri=" + this.resourceURL;//$NON-NLS-1$
			var dialog = new ExportDialog({
				serviceUrl: url,
				message: dojo.string.substitute(this.messages.ProcessDescriptionListPage_16, [UIHelper.escapeXML(this._getProcessDescriptionName())])
			});
		},
		
		handleLock: function(lockRequest, byForce) {
			this._handleLock(lockRequest, byForce, false);
		},
		
		initTreePane: function() {
			this.practicePane = new dijit.layout.ContentPane({
				title: this.messages.ProcessDescriptionEditor_5,
				selected: "true" //$NON-NLS-1$
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.leftNavigator.addChild(this.practicePane);
			
			if (this.isNew === true) {
				this._showUIForCreation();
			} else {
				this._showUIForEditing();
			}
		},
		
		switchLanguage: function(evt) {
			dojo.stopEvent(evt);
			var languageDialog = new ProcessDescriptionLanguageDialog({
				controller: this,
				resource: this.resourceURL,
				owner: this._getOwner(),
				viewOnly: this.viewOnly,
				workingCopy: this.workingCopy
			});
		},
		
		_showUIForCreation: function() {
			//setup detail field
			this._createDetailEditor(this.isShared);
			if ( this.isShared ) {
				this.detailEditor.sharingCheckType = ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_UNCHECKED;
			}
			this.detailWrapper.appendChild(this.detailEditor.domNode);
			this.resetAllFields();
			this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.EDIT);
		},
		
		_showUIForEditing: function() {
			this.isRefreshCalled = false; 
			this.loadData();
		},
		
		_hidePracticeTree: function() {
			dojo.toggleClass(this.contentWrapper, ProcessAuthoringConstants.CSS_HIDE, true); 
		},
		
		loadData: function() {
			var languageParameter = this.workingCopy.currentLanguage ? "?lang=" + this.workingCopy.currentLanguage : ""; //$NON-NLS-1$ //$NON-NLS-2$
			ProcessAuthoringClient.getProcessDescription({
				lastModified: this.workingCopy.lastModified,
				resourceURL: this.resourceURL + languageParameter,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.processDescriptionETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
					this.populateData(data);
					this.resizeEditor();
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					//TODO report error bug 104182
					if (error.responseText && error.status == ProcessAuthoringConstants.SC_FORBIDDEN) {
						error.headerMessage = this.messages.ProcessDescriptionError_3;
						this._handleResponseError(error, ioArgs, true);
					} else {
						this.displayErrorMessage(error);
					}
				})
			});
		},
		
		populateData: function(data) {
			var pd = new PracticeElement({
				xml: data
			});
			this.processDescriptionXML = data;
			this.isShared = pd.isSharedByOwner();
			this.isPLMShared = pd.isSharedByElement();
			this.processDescriptionLanguage = pd.language;
			this.processDescriptionName = pd.title;
			this.processDescriptionOwner = pd.getOwnerURL();
			this.processDescriptionOwnerName = pd.getOwnerName();
			this.processDescriptionId = this.resourceURL.substring(this.resourceURL.lastIndexOf('/') + 1); //$NON-NLS-1$
			this.processDescription = pd.description;
			
			this.workingCopy.currentLanguage = this.processDescriptionLanguage;
			this.workingCopy.sharedSupport = this.sharedSupport;
			var languages = pd.languages;
			this.workingCopy.addProcessDescription({
				resourceURL: this.resourceURL,
				title: this.processDescriptionName,
				description: this.processDescription,
				owner: this.processDescriptionOwner,
				ETag: this.processDescriptionETag,
				isPLMShared: this.isPLMShared,
				languages: languages,
				practiceList: []
			});
			
			if (this.isNew) {
				this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
			} else {
				this._toggleHiddenButtons(false);
				if (!this.detailEditor) {
					this._createDetailEditor(this.isShared);
					this.detailWrapper.appendChild(this.detailEditor.domNode);
				}
				if (!this.switchLanguageToolbar) {
					this.switchLanguageToolbar = new jazz.ui.SimpleToolbar({});
					this.detailEditor.switchLanguageButtonContainer.appendChild(this.switchLanguageToolbar.domNode);
					
					this.switchLanguageToolbar.addButton(this, this.switchLanguage, {
						imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/language-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
						label: this.messages.ProcessDescriptionEditor_16
					});
				}
				
				this.detailEditor.displayLanguage(true);
				this.detailEditor.setLanguage(this.getFullLanguage(this.processDescriptionLanguage));
				this.detailEditor.attr("ownerReadOnly", true); //$NON-NLS-1$
				if (this.viewMode) {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.PREVIEW);
				} else {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
				}
				this.detailEditor.defaultField.checked = this._isDefaultLanguage();
			}
			
			this.resetAllFields();
			this.initializeNavigator();
		},
		
		_isDefaultLanguage: function() {
			return this.workingCopy.currentLanguage == this.workingCopy.processDescription.defaultLanguage;
		},
		
		_setDefaultLanguage: function(evt) {
			this.workingCopy.setProcessDescriptionDefaultLanguage(evt.target.checked ? this.workingCopy.currentLanguage : null);
		},
		
		_createDetailEditor: function(isShared) {
			var args = {
				descriptionContent: this.processDescription,
				ownerURL: this.processDescriptionOwner,
				languageText: this.processDescriptionLanguage,
				hideOwner: isShared,
				hideLanguage: this.isNew,
				isNew: this.isNew,
				container: this,
				viewOnly: this.viewOnly,
				viewMode: this.viewMode
			}
			if ( isShared && UIHelper.isPracticeLibraryApp() ) {
				args.sharingCheckType = this.isPLMShared? ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_CHECKED:ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_UNCHECKED;				
			}
			if ( !this.isNew ) {
				args.onSize = dojo.hitch(this, this.resizeEditor);
			}
			
			this.detailEditor = new ProcessDescriptionDetailEditor(args);
            if (!this.viewOnly) {
            	var inputFields = [this.detailEditor.description, this.detailEditor.owner];
            	for (var i = 0; i < inputFields.length; i++) {
            		this.connect(inputFields[i], "onkeyup", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            		this.connect(inputFields[i], "onchange", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            	}
            	this.connect(this.detailEditor.sharingField, "onclick", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            	this.connect(this.detailEditor.defaultField, "onclick", "_handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
            }
		},
		
		_onPLMSharingChange: function() {
			this.isPLMShared = this.detailEditor.sharingField.checked;
		},		
		 
		resetAllFields: function() {
			this.name.value = this.processDescriptionName ? this.processDescriptionName : this.messages.ProcessDescriptionEditor_7;
			this.name.style.display = "none"; //$NON-NLS-1$
			this.previewName.innerHTML = UIHelper.escapeXML(this.name.value);
			this.previewName.style.display = ""; //$NON-NLS-1$
			this.detailEditor.setDescription(this.processDescription);
			if (!this.isShared) {
				var url = this.processDescriptionOwner ? this.processDescriptionOwner : this.DEFAULT_PROCESSDESCRIPTION_OWNERURL;
				var name = this.processDescriptionOwnerName ? this.processDescriptionOwnerName : url;
				this.detailEditor.setOwner(url, name);
			}
		},
		
		_changeToEditMode: function() {
			//setup practice panel
			dojo.toggleClass(this.contentWrapper, ProcessAuthoringConstants.CSS_HIDE, false);
			this.isNew = false;
			this.clearChangesPending();
			this.refresh();
		},
		
		initializeNavigator: function() {
			if (this.practiceElementId) {
				this.workingCopy.currentItem = this.practiceElementId;
			} else if (this.practiceId) {
				this.workingCopy.currentItem = this.practiceId;
			}
			this.fetchProcessDescriptionTree(this.resourceURL);
			var practiceInfoList = UIHelper.getAllPracticesFromProcessDescription(this.processDescriptionXML);
			// clear XML data from memory since it will no longer be used
			this.processDescriptionXML = null;
			
			//load practice tree
			this.practiceTreePane = new PracticeTreePane({
				onAddPractice: dojo.hitch(this, this.onAddPractice),
				viewOnly: this.viewOnly,
				isAssociated: this.viewOnly
			});
			this.practicePane.attr('content', this.practiceTreePane); //$NON-NLS-1$

            if (practiceInfoList.length === 0 && this.isGadget) {
				this.clearLoadingMessage();
            }
			
			//process description contains all the practice references even missing readShared license. we need to calculate the real number of practices to be load. 
			this.totlePracticesNum = practiceInfoList.length; 
			if (!this.sharedSupport) {
				for (var i = 0; i < practiceInfoList.length; i++) {
					if (practiceInfoList[i].shared === "true") { //$NON-NLS-1$
						this.totlePracticesNum--;
					}
				}
			}
			
			this.loadedPracticesNum = 0;
			for (var i = 0; i < practiceInfoList.length; i++) {
				var practiceInfo = practiceInfoList[i];
				if (practiceInfo.shared === "true") { //$NON-NLS-1$
					this.workingCopy.addPracticeToPracticeList({
						url: practiceInfo.url,
						name: practiceInfo.title,
						shared: "true" //$NON-NLS-1$
					}, false);
					if (this.sharedSupport) {
						if (i == practiceInfoList.length - 1) {
							this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, true, this.totlePracticesNum);
						} else {
							this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, true);
						}
					} else {
						if (!this.hasTryToLoadShared) {
							this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, true);
							this.hasTryToLoadShared = true;
						}
						if (i == practiceInfoList.length - 1) {
							dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
						}
					}
				} else {
					this.workingCopy.addPracticeToPracticeList({
						url: practiceInfo.url,
						name: practiceInfo.title,
						shared: "false" //$NON-NLS-1$
					}, false);
					if (i == practiceInfoList.length - 1) {
						this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, false, this.totlePracticesNum);
					} else {
						this.loadPracticeTree(practiceInfo.url, this.practiceTreePane, false);
					}
				}
			};
			
			if (!this.viewOnly && this.isFirstLoad) {
				var nodeList = dojo.query('.dijitAccordionTitle'); //$NON-NLS-1$
				if (this.sharedSupport) {
					this.editToolBar_AddSharedPractice = new jazz.ui.SimpleToolbar({});
					dojo.style(this.editToolBar_AddSharedPractice.domNode, "float", "right"); //$NON-NLS-1$ $NON-NLS-2$
					this.editToolBar_AddSharedPractice.addButton(this, dojo.hitch(this, this._onAddSharedPracticeButtonClick), {
						imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/add-shared-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
						label: this.messages.PracticeTreePane_4
					});
				}
				
				this.editToolBar_AddPrivatePractice = new jazz.ui.SimpleToolbar({});
				dojo.style(this.editToolBar_AddPrivatePractice.domNode, "float", "right"); //$NON-NLS-1$ $NON-NLS-2$
				this.editToolBar_AddPrivatePractice.addButton(this, dojo.hitch(this, this._onAddPrivatePracticeButtonClick), {
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/new-private-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					label: this.messages.PracticeTreePane_0
				});
				
				this.editToolBar_AddPrivatePractice.addButton(this, dojo.hitch(this, this._onImportPracticesButtonClick), {
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/import-practice_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					label: this.messages.PracticeTreePane_3
				});

				var index = this.outlinePane ? 1 : 0;
				if (this.sharedSupport) {
					dojo.place(this.editToolBar_AddSharedPractice.domNode, nodeList[index], "first"); //$NON-NLS-1$
				}
				dojo.place(this.editToolBar_AddPrivatePractice.domNode, nodeList[index], "first"); //$NON-NLS-1$
				this.isFirstLoad = false;
				if (this.viewMode) {
					dojo.addClass(this.editToolBar_AddPrivatePractice.domNode, ProcessAuthoringConstants.CSS_HIDE);
					if (this.sharedSupport) {
						dojo.addClass(this.editToolBar_AddSharedPractice.domNode, ProcessAuthoringConstants.CSS_HIDE);
					}
				}
			}
		},
		
		_onImportPracticesButtonClick: function() {
            this.leftNavigator.selectChild(this.practicePane);
            if ((!this.changesPending()) || (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_21))) {
            	var dialog = new ImportDialog({
            		processDescriptionUrl: this.resourceURL
            	});
            	this.connect(dialog, "onSuccess", "handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
            }
		},
		
		handleImportSuccess: function(args) {
			if (typeof(args.resourceCount) === 'undefined') { //$NON-NLS-1$
				return;
			}
			var resourceUrlPrefix = args.resourceUrlPrefix;
			var resourceIdArray = args.resourceIds.split(":"); //$NON-NLS-1$
			for (var i = 0; i < args.resourceCount; i++) {
				this.workingCopy.addPracticeToPracticeList({
					url: resourceUrlPrefix + resourceIdArray[i],
					name: "", //$NON-NLS-1$
					shared: "false" //$NON-NLS-1$
				}, true);
			}
			this.doSave();
		},
		
		loadPracticeTree: function(url, treePane, shared, totalNum) {
			this.fetchPracticeTree(url, treePane, shared, dojo.hitch(this, function() {
				this.openCurrentItem(treePane, shared);
				if (totalNum && this.practicesLoadDoneHandle) {
					if (this.loadedPracticesNum == totalNum) {
						dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
					} else {
						var id = window.setInterval(dojo.hitch(this, function() {
							if (this.loadedPracticesNum == totalNum) {
								dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
								window.clearInterval(id); 
							}
						}), 1000);
					}
				}
			}));
		},
		
		togglePrimaryField: function(mode) {
			if (mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessAuthoringConstants.NONE;
				dojo.empty(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.name.value || this.messages.ProcessDescriptionEditor_7));
				this.previewName.style.display = ProcessAuthoringConstants.EMPTY;
			} else if (mode === ProcessAuthoringConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessAuthoringConstants.NONE;
				this.name.style.display = ProcessAuthoringConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		loadError: function() {
			//TODO error handling
		},
		
		refresh: function() {
			this._clearMessage();					
			this.inherited(arguments);
			this.workingCopy.clean();
			this.practicePane.attr('content', ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.isRefreshCalled = true; 
			this.loadData();
		},
		
		onRefresh: function(e) {
            if (e) {
            	dojo.stopEvent(e);
            }
            if (this.isNew) {
				if (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_8)) {
					this.clearChangesPending();
					this.processDescriptionName = this.messages.ProcessDescriptionEditor_7;
					this.processDescription = ""; //$NON-NLS-1$
					dojo.empty(this.detailWrapper);
					this._showUIForCreation();
				}
			} else {
				if (!this.changesPending() || (this.changesPending() && confirm(this.messages.ProcessDescriptionEditor_8))) {
					this.refresh();
				}
			}
		},
		
		getResult: function(results) {
			if (this.inherited(arguments)) {
				this.displaySuccessMessage(this.messages.ProcessDescriptionEditor_2);
				return true;
			}
			return false;
		},
		
		doSave: function() {
			this.autoCommitEditor();
			
			var msg = this.validateFields();
			if (msg) {
				this.displayErrorMessage(msg);
				return;
			}
			
			this.displayWaitingMessage(this.messages.ProcessDescriptionEditor_13);
			
			if (this.isNew === true) {
				//url is like this: https://localhost:9443/jazz/process/project-areas/_EsMFQg_MEd-YF9W184A5vA
				var successCallback = dojo.hitch(this, function(location, ETag) {
					this.resourceURL = location;
					this.processDescriptionETag = ETag;
					this._changeToEditMode();
					if (this.saveResultCallback) {
						this.saveResultCallback();
					} else {
						this.displaySuccessMessage(this.messages.ProcessDescriptionEditor_0);
					}
				});
				var errorCallback = dojo.hitch(this, function(error) {
					//TODO more details for save failure
					if (error.responseText) {
						error.message = error.responseText;
					}
					if (!error.headerMessage) {
						error.headerMessage = this.messages.ProcessDescriptionError_0;
					}
					if (this.saveResultCallback) {
						this.saveResultCallback(error);
					} else {
						this.displayErrorMessage(error);
					}
				});
				if (this.isShared) {
					ProcessAuthoringClient.createSharedProcessDescription({
						title: UIHelper.escapeXML(this.processDescriptionName),
						isPublished: this.isPLMShared,
						description: this.processDescription,
						successCallback: successCallback,
						errorCallback: errorCallback
					});
				} else {
					ProcessAuthoringClient.createProcessDescriptionForProcessArea({
						title: UIHelper.escapeXML(this.processDescriptionName),
						description: this.processDescription,
						language: this.workingCopy.currentLanguage,
						ownerUrl: this._getOwner(),
						successCallback: successCallback,
						errorCallback: errorCallback
					});
				}
			} else {
				this.inherited(arguments);
			}
		},
		
		validateFields: function() {
			if (!this._getProcessDescriptionName() || dojo.trim(this._getProcessDescriptionName()).length === 0) {
				return this.messages.ProcessDescriptionEditor_9;
			}
			if (!this.isShared) {
				if (!this.processDescriptionOwner || dojo.trim(this.processDescriptionOwner).length === 0) {
					return this.messages.ProcessDescriptionEditor_10;
				}
			}
			if (this.workingCopy.processDescription && !this.workingCopy.processDescription.defaultLanguage) {
				return this.messages.ProcessDescriptionEditor_27;
			}
		},
		
		_handleChange: function(e) {
			//don't stop the event propagation for checkbox, otherwise, the checkbox UI will not change
			if ( e.currentTarget.type !== "checkbox") { //$NON-NLS-1$ 
				dojo.stopEvent(e);
			}
			var hasUpdate = true;
			switch (e.currentTarget.name) {
				case this.TITLE_LABEL:
					hasUpdate = !(this.processDescriptionName === e.target.value);
					if (hasUpdate) {
						this._getProcessDescriptionName(hasUpdate);
					}
					break;
				case this.OWNER_LABEL:
					if (this.detailEditor.attr("ownerReadOnly")) { //$NON-NLS-1$
						return;
					}
					hasUpdate = !(this.processDescriptionOwner === e.target.value);
					if (hasUpdate) {
						this._getOwner(hasUpdate);
					}
					break;
				case this.PLMSHARED_TARGET:
					hasUpdate = true;
					this._onPLMSharingChange();
					break;
				case "default": //$NON-NLS-1$
					this._setDefaultLanguage(e);
					break;
				default:
					hasUpdate = !(this.processDescription === e.target.value);
					if (hasUpdate) {
						this._getDescription(hasUpdate);
					}
					break;
			}
			
			if (hasUpdate) {
				if (!this.isNew) {
					this._updateWorkingCopy();
				}
				this.setChangesPending();
			}
		},
		
		_onAddSharedPracticeButtonClick: function(evt) {
			dojo.stopEvent(evt);
			this.onAddSharedPractice(this.practiceTreePane);
		},
		
		_onAddPrivatePracticeButtonClick: function(evt) {
			dojo.stopEvent(evt);
            this.leftNavigator.selectChild(this.practicePane);
			this.onAddPractice(this.practiceTreePane);
		},
		
		onAddSharedPractice: function(treePane) {
			//callbackFunction
			var sharedPracticePicker = new SharedPracticeSelectionDialog({
				selectedResources: this.workingCopy.getPracticeList()
			});
			this.connect(sharedPracticePicker, "onAdd", "addSharedPractice"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		addSharedPractice: function(selectedPractices) {
			dojo.forEach(selectedPractices, function(practice) {
				if (!this.workingCopy.practiceIndexMap[practice.url]) {
					this.workingCopy.addPracticeToPracticeList({
						name: practice.name,
						url: practice.url,
						shared: "true" //$NON-NLS-1$
					}, true);
					this.fetchPracticeTree(practice.url, this.practiceTreePane, true);
					this.setChangesPending();
				}
			}, this);
		},
		
		onRemoveSharedPractice: function(item, practiceResource, treeContainer) {
			if (confirm(dojo.string.substitute(this.messages.ProcessDescriptionEditor_11, [item.label]))) {
				treeContainer.removePracticeTree(practiceResource);
				this.workingCopy.removePracticeFromPracticeList(practiceResource);
				this.setChangesPending();
				if (this.workingCopy.isParent(practiceResource, practiceResource, this.workingCopy.currentItem)) {
					this.rightContent.attr('content', ''); //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
		},
		
		handlePromoteError: function(err, ioArgs) {
			var licenseWarning = null;
			if (ioArgs) {
				licenseWarning = UIHelper.getLicenseWarning(ioArgs);
			}
			var result = {
				success: false,
				headerMessage: licenseWarning ? licenseWarning : this.messages.ProcessDescriptionError_1,
				type: "promotePrivatePractice", //$NON-NLS-1$
				message: err.status == ProcessAuthoringConstants.SC_FORBIDDEN ? err.responseText : err.message,
				errorData: err
			}
			this.getResult([result]);
		},
		
		onPromotePractice: function(item, practiceResource, treeContainer) {
            
            if ( confirm(dojo.string.substitute(this.messages.ProcessDescriptionEditor_24, [item.label]))) {
                if (!this.changesPending() || (this.changesPending() && confirm(this.messages.AbstractPracticesEditor_7))) {
					
					var practice = this.workingCopy.getPracticeInPracticeList(practiceResource);
					if (practice) {
						practice.shared = "true"; //$NON-NLS-1$
					}
					
                	//update process description and practice
                	this._doPromote(practiceResource);
                	treeContainer.removePracticeTree(practiceResource);
                }
            }
			
		},		
		
		_doPromote: function(practiceResource) {
            var funcs = [this.updatePractice, this.updateProcessDescriptionPracticeList];
            var i = 0;
            var _self = this;
            loop();

            function loop() {
            	//end of the promoting, refresh
            	if (i >= funcs.length) {
            		_self.refresh();
					_self.displaySuccessMessage(_self.messages.ProcessDescriptionEditor_25);
            	} else {
            		funcs[i++].call(_self, practiceResource, loop);
            	}
            }
		},
		
		updateProcessDescriptionPracticeList: function(practiceResource, callback) {
			
            ProcessAuthoringClient.updateProcessDescriptionPracitceList({
            	language: this.workingCopy.currentLanguage, 
            	itemId: this.processDescriptionId,
				owner: this.processDescriptionOwner,
            	ETag: this.processDescriptionETag,
            	practiceList: this.workingCopy.getPracticeList(),
            	load: dojo.hitch(this, function(data, ioArgs) {
            		this.processDescriptionETag = ioArgs.xhr.getResponseHeader("Etag"); //$NON-NLS-1$
            		this.workingCopy.lastModified = ioArgs.xhr.getResponseHeader("Last-Modified"); //$NON-NLS-1$
            		callback();
            	}),
            	error: dojo.hitch(this, function(err, ioArgs) {
            		this.handlePromoteError(err, ioArgs);
            	})
            });
		},
		
		updatePractice: function(practiceResource, callback) {
            ProcessAuthoringClient.getPractice({
            	lastModified: this.workingCopy.lastModified, //$NON-NLS-1$
            	url: practiceResource,
            	load: dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
            		var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
            		var practice = new PracticeElement({
            			xml: data
            		});
            		
            		ProcessAuthoringClient.updatePractice({
            			ETag: ETag,
            			putData: practice.getPromotedElementXML(),
            			practiceId: practice.getElementID(),
            			load: dojo.hitch(this, function(data, ioArgs) {
            				this.workingCopy.lastModified = ioArgs.xhr.getResponseHeader("Last-Modified"); //$NON-NLS-1$
							callback();
            			}),
            			error: dojo.hitch(this, function(err, ioArgs) {
							this.handlePromoteError(err, ioArgs);
            			})
            		});
            	}),
                error: dojo.hitch(this, function(err, ioArgs) {
                	this.handlePromoteError(err, ioArgs);
                })
            });
		},
		
		_updateWorkingCopy: function() {
			this.workingCopy.updateProcessDescription({
				resourceURL: this.resourceURL,
				isPLMShared: this.isPLMShared,
				title: this.processDescriptionName,
				description: this.processDescription,
				owner: this.processDescriptionOwner
			});
		},
		
		_getProcessDescriptionName: function(hasUpdate) {
			this.processDescriptionName = this.name.value;
			return this.processDescriptionName;
		},
		
		_getDescription: function() {
			this.processDescription = this.detailEditor.description.value;
			return this.processDescription;
		},
		
		_getOwner: function() {
			//comment it, currently, owner can't be modified, and the value is ownerName, that's not what want.
			//			this.processDescriptionOwner = this.detailEditor.owner.value;
			return this.processDescriptionOwner;
		},
		
		getModelETag: function() {
			return this.workingCopy.processDescription.model.ETag;
		},
		
		setETag: function(ETag) {
			this.processDescriptionETag = ETag;
			this.workingCopy.processDescription.model.ETag = UIHelper.extractETag(ETag).modelETag;
		},
		
		getResourceID: function() {
			return this.resourceURL.substring(this.resourceURL.lastIndexOf("/") + 1, this.resourceURL.length); //$NON-NLS-1$
		},
		
		uninitialize: function() {
			if (this.detailEditor) {
				this.detailEditor.destroyRecursive();
			}
			
			if (this.switchLanguageToolbar) {
				this.switchLanguageToolbar.destroyRecursive();
			}
			
			if (this.editToolBar_AddSharedPractice) {
				this.editToolBar_AddSharedPractice.destroyRecursive();
			}
			
			if (this.editToolBar_AddPrivatePractice) {
				this.editToolBar_AddPrivatePractice.destroyRecursive();
			}
			
			this.inherited(arguments);
		},
		
		fetchPractices: function(practiceNodes, urlToXmlMap, onFinish) {
			var node = practiceNodes.shift();
			if(node) {
				var url = UIHelper.getNodeResource(node);
				if(url) {
					ProcessAuthoringClient.getResource({
						lastModified: this.workingCopy.lastModified,
						url: url + "?lang=" + this.workingCopy.currentLanguage + "&view=structure", //$NON-NLS-1$ //$NON-NLS-2$
						load: dojo.hitch(this, function(data, ioArgs) {
							urlToXmlMap[url] = data;
							this.fetchPractices(practiceNodes, urlToXmlMap, onFinish);
						})
					});
				} else {
					this.fetchPractices(practiceNodes, urlToXmlMap, onFinish);
				}
			} else {
				onFinish();
			}
		},
		
		fetchProcessDescriptionTree: function(url) {
			ProcessAuthoringClient.getResource({
				lastModified: this.workingCopy.lastModified,
				url: url + "?lang=" + this.workingCopy.currentLanguage + "&view=structure", //$NON-NLS-1$ //$NON-NLS-2$
				load: dojo.hitch(this, function(data, ioArgs) {
					var presentations = dojo.query(ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, data);
					if (presentations && presentations.length > 0) {
						var eTag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
						// find URLs of all practices
						var practiceNodes = dojo.query(ProcessAuthoringConstants.XMLELEMENT_PRACTICE, data);
						var urlToXmlMap = {};
						this.fetchPractices(practiceNodes, urlToXmlMap, dojo.hitch(this, function() {
							// Outline pane
							// show outline pane only if process description has a structure presentation
							//
                            
                            if (!this.outlinePane) {
                            	this.outlinePane = new dijit.layout.ContentPane({
                            		title: this.messages.ProcessDescriptionEditor_18,
                            		selected: "true", //$NON-NLS-1$
                            		disabled: false
                            	}, document.createElement("DIV")); //$NON-NLS-1$
                            	this.leftNavigator.addChild(this.outlinePane, 0);
                            	if (this.viewMode) {
                            		this.leftNavigator.selectChild(this.outlinePane);
                            	} else {
                            		this.leftNavigator.selectChild(this.practicePane);
                            		this.outlinePane.disabled = true;
                            	}
                            }
							// load process description outline
							this.processDescriptionTreePane = new PracticeTreePane({
								viewOnly: true,
								isOutlinePane: true,
								isAssociated: this.viewOnly
							});
							this.outlinePane.attr('content', this.processDescriptionTreePane); //$NON-NLS-1$
							var navData = new NavigationData({
								isOutlineData: true,
								eTag: eTag,
								xmlData: data,
								urlToXmlMap: urlToXmlMap
							});
							var jsonData = navData.getJsonData();
							var tree = this.createTree(jsonData, this.processDescriptionTreePane, true, false);
							this.processDescriptionTreePane.addPracticeTree(tree);
						}));
					}
				}),
				error: dojo.hitch(this, function() {
				
				})
			});
		},
        
		getTreeIndex: function(url) {
			for (var i = 0; i < this.workingCopy.processDescription.model.practiceList.length; i++) {
				var practiceUrl = this.workingCopy.processDescription.model.practiceList[i].url;
				if (practiceUrl === url) {
					return i;
				}
			}
		},
		
		fetchPracticeTree: function(url, treeContainer, isShared, callback) {
			ProcessAuthoringClient.getPractice({
				lastModified: this.workingCopy.lastModified,
				url: url + "?lang=" + this.workingCopy.currentLanguage, //$NON-NLS-1$
				load: dojo.hitch(this, function(data, ioArgs) {
					var practiceETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
					var practiceJsonData = this.convertXMLtoJsonData(data, practiceETag);
					if (isShared) {
						practiceJsonData.isShared = true;
					}
					this.loadedPracticesNum++;
					this.workingCopy.addPractice(dojo.clone(practiceJsonData));
					var tree = this.createTree(practiceJsonData, treeContainer, false, isShared);
					tree.indexInParent = this.getTreeIndex(tree.practiceResource);
					treeContainer.addPracticeTree(tree);
					if (dojo.isFunction(callback)) {
						callback();
					}
				}),
				error: dojo.hitch(this, function(error, ioArgs) {
					var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
					if (error.responseText && error.status == ProcessAuthoringConstants.SC_FORBIDDEN && licenseWarning) {
						error.message = error.responseText;
						error.headerMessage = this.messages.ProcessDescriptionEditor_1;
						this.displayWarningMessage(error, false);
					} else {
						this.displayErrorMessage(error);
					}
				})
			});
		},
		
		reload: function() {
			var basicInformation = this.workingCopy.getProcessDescriptionBasicInformationForCurrentLangugage();
			this.detailEditor.setDescription(basicInformation.description);
			this.detailEditor.setLanguage(this.getFullLanguage(this.workingCopy.currentLanguage));
			this.detailEditor.defaultField.checked = this._isDefaultLanguage();
			this.name.value = basicInformation.label;
			this.processDescriptionLanguage = this.workingCopy.currentLanguage;
			this.processDescriptionName = basicInformation.label;
			this.processDescription = basicInformation.description;

			this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.PREVIEW);
			this.initializedContentEditor = false;
			
			this.practiceTreePane.removePracticeTrees();
			dojo.forEach(this.workingCopy.practiceList, function(practice) {
				if (practice.isShared && !this.workingCopy.sharedSupport) {
					return;
				}
				this.workingCopy.getTreeJsonArray(practice, dojo.hitch(this, function(treeData) {
					var tree = this.createTree(treeData, this.practiceTreePane, false, practice.isShared);
					tree.indexInParent = this.getTreeIndex(tree.practiceResource);
					this.practiceTreePane.addPracticeTree(tree);
					this.openCurrentItem(this.practiceTreePane, practice.isShared ? true : false);
				}), true);
			}, this);
		}
	});
})();
