/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.jfs.web.ui.internal.editors.ProcessDescriptionEditorContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper");//$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.jfs.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.requireLocalization("jazz.app.internal", "LoginWidgetMessages"); //$NON-NLS-1$ //$NON-NLS-2$	 
	
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	
	dojo.declare("com.ibm.team.process.authoring.jfs.web.ui.internal.editors.ProcessDescriptionEditorContainer", com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorContainer, { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.jfs.web", "ui/internal/editors/templates/ProcessDescriptionEditorContainer.html"), //$NON-NLS-1$ //$NON-NLS-2$
		_gadgetURL: UIHelper.getURLPrefix() + "/web/com.ibm.team.process.authoring.jfs.web/ProcessDescriptionEditor", //$NON-NLS-1$
		licenseInfo: null,
		fetchError: null, // "popupBlocked" or "cancel"
		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.jfs.web.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this._createProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/create-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._importProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/import-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._associateProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/copyurl-button.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._dissociateProcessDescriptionIcon.src = dojo.moduleUrl("com.ibm.team.process.authoring.web", "graphics/icons/dis-proc-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$			
			this.inherited(arguments);
		},
		
		hideAllLinks: function() {
            dojo.style(this._welcomeSection, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._createProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._importProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._associateProcessDescriptionLink, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
            dojo.style(this._actionBar, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		clearMessage: function() {
			this.editor._pendingMessageBox.hideMessage();
		},
		
		setDirty: function(isDirty, editingProcessDescriptionName) {
			this.hasChange = isDirty;
			this.editingProcessDescriptionName = editingProcessDescriptionName;
			this.editor.setDirty(this.editor.changesPending());
		},
		
		canSave: function() {
			if (this.editingProcessDescriptionName === undefined || (this.editingProcessDescriptionName !== undefined && this.editingProcessDescriptionName) || this.editor.discardPending) {
				return true;
			} else {
				return false;
			}
		},
		
		changesPending: function() {
			return this.hasChange;
		},
		
		refresh: function() {
			//refresh only when this is the selected tab(this is because the cache doesn't work for gadget)
			if ( this.editor._tabs[this.editor.selectedTab].mainPage !== this ) {
				return;
			}
			this.saveAction = null;
			this.hasChange = false;
			this.fetchProcessDescription();
		},

		displaySuccessMessage: function(msg) {
			this.editor._displayLongSuccessMessage(msg);
		},
		
		displayErrorMessage: function(msg) {
			this.editor._displayLongErrorMessage(msg);
		},
		
		displayPendingMessage: function(msg) {
			this.editor._displayPendingMessage(msg);
		},
		
		deactivateTab: function() {
			if (!this.fetchError) {
				this.clearMessage();
				if (this.hasChange) {
					if (!confirm(this.messages.ProcessDescriptionEditorContainer_10)) {
						return false; //veto the navigate
					}
				}
				
				if (this.gadget) {
					this.gadget.destroyRecursive();
					this.gadget = null;
				}
				
				this.setDirty(false);
			}
			
			return true;
		},
		
		activateTab: function() {
			if (this.fetchError) {
				this._showFetchError();
			} else {
				this.displayPendingMessage(messages.ProcessDescriptionEditor_23);
				this.populateAuthoringProcessDescription();
			}
		},
		
		getOwnerUrl: function(contextRoot) {
			if (!this.editor.isNew) {
				if (this.editor.isTeamArea) {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_TEAM_AREA_OWNER_TEMPLATE, [contextRoot, this.editor.projectAreaItemId, this.editor.itemId]);
				} else {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_PROJECT_AREA_OWNER_TEMPLATE, [contextRoot, this.editor.projectAreaItemId]);
				}
			}
			
			return null;
		},
		
		getOwnerName: function() {
			return this.editor.name.savedValue;
		},
		
		initialize: function(args) {
			if (args.editor) {
				this.editor = args.editor;
				this.licenseInfo = this.editor.processAuthoringlicenseInfo;
				this.processAuthoringPracticeId = this.editor.processAuthoringPracticeId;
				this.processAuthoringPracticeElementId = this.editor.processAuthoringPracticeElementId;
				
				// get public URI root of current foundation fronting app
				jazz.client.xhrGet({
					preventCache: true,
					url: net.jazz.ajax._contextRoot + ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART + "friend/uriRoot", //$NON-NLS-1$
					handleAs: "json", //$NON-NLS-1$
					load: dojo.hitch(this, function(data, ioArgs) {
						this.ownerUrl = this.getOwnerUrl(data.uriRoot);
						this.fetchProcessDescription();
					}),
					error: dojo.hitch(this, function(error, ioArgs) {
						this.displayErrorMessage(error);
					})
				});

			}
		},
		
		assertOperation: function(operationId){
			if (this.licenseInfo) {
				var splitLicenses = this.licenseInfo.split(";"); //$NON-NLS-1$
				for (var i = 0; i < splitLicenses.length; i++) {
					var licensePair = splitLicenses[i].split(":"); //$NON-NLS-1$
					if (licensePair[0] === operationId) { //$NON-NLS-1$
						return licensePair[1] === "true"; //$NON-NLS-1$
					}
				}
			} else {
				return false;
			}
		},
		
		_setFetchError: function(error, ioArgs) {
			this.fetchError = error;
			this.fetchError.status = ioArgs.xhr.status;
			if (this.fetchError.responseText) {
				this.fetchError.message = this.fetchError.responseText;
				if (this.fetchError.status === ProcessAuthoringConstants.SC_FORBIDDEN) {
					this.fetchError.headerMessage = messages.ProcessDescriptionError_3;
				}
			}
		},
		
		fetchProcessDescription: function(){
			this.fetchError = null;
			this.displayPendingMessage(messages.ProcessDescriptionEditor_23);
			ProcessAuthoringClient.checkProcessDescriptionForProcessArea({
            	itemId: this.editor.itemId,
				processAreaType: this.editor.isTeamArea ? "team-area" : "project-area",  //$NON-NLS-1$ //$NON-NLS-2$
            	load: dojo.hitch(this, function(data, ioArgs){
            		this.resourceUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
            		this.populateAuthoringProcessDescription();
            	}),
            	error: dojo.hitch(this, function(error, ioArgs){
					if (ioArgs.xhr.status === ProcessAuthoringConstants.SC_NOT_FOUND || ioArgs.xhr.status === ProcessAuthoringConstants.SC_GONE) {  //no process description
						var targetUrl = this.ownerUrl; //$NON-NLS-1$
						// TODO: this needs to be improved, 3 calls (ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea,
						// ProcessAuthoringClient.getAssociation, jazz.client.xhrHead) should be reduced to 1.
						// See https://jazz.net/jazz/resource/itemName/com.ibm.team.workitem.WorkItem/166775
						ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
							targetUrl: targetUrl,
							load: dojo.hitch(this, function(data, ioArgs) {
								var associationUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
								ProcessAuthoringClient.getAssociation({
									url: associationUrl,
									load: dojo.hitch(this, function(data, ioArgs) {
										var docElement = data.documentElement;
										dojo.some(docElement.childNodes, function(node) {
											if (node.nodeType == ProcessConstants.NodeType.ELEMENT) {
												if (UIHelper.isSpecifiedNode(node, "source", ProcessConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
													var sourceUrl = UIHelper.getAttributeNode(node, ProcessConstants.XMLATTRIBUTE_RESOURCE, ProcessConstants.NAMESPACE_RDF).value;
													if (sourceUrl !== null) {
														this.resourceUrl = sourceUrl;
														return true;
													} else {
														return false;
													}
												}
											}
										}, this);
																				
										if (this.resourceUrl) {
											jazz.client.xhrHead({
												url: this.resourceUrl,
												headers: {
													Accept: "application/xml" //$NON-NLS-1$
												},
												handleAs: "xml", //$NON-NLS-1$
												load: dojo.hitch(this, function(data, ioArgs) {
													this.isAssociated = true;
													this.populateAuthoringProcessDescription();
												}),
												error: dojo.hitch(this, function(error, ioArgs) {
													this.resourceUrl = null;
													if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND && 
														ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { //no process description
														this._setFetchError(error, ioArgs);
													}
													this.populateAuthoringProcessDescription();
												})
											});
										} else {
											this.populateAuthoringProcessDescription();
										}

									}),
									error: dojo.hitch(this, function(error, ioArgs) {
										this.resourceUrl = null;
										if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND && ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { // no association
											this._setFetchError(error, ioArgs);
										}
										this.populateAuthoringProcessDescription();
									})
								});
							}),
							error: dojo.hitch(this, function(error, ioArgs) {
								this.resourceUrl = null;
								if (ioArgs.xhr.status !== ProcessAuthoringConstants.SC_NOT_FOUND && ioArgs.xhr.status !== ProcessAuthoringConstants.SC_GONE) { // no association
									this._setFetchError(error, ioArgs);
								}
								this.populateAuthoringProcessDescription();
							})
						});
					} else {
						this._setFetchError(error, ioArgs);
						this.populateAuthoringProcessDescription();
					}
            	})
            });
		},
		
		discardProcessDescription: function(itemId){
			if (this.resourceUrl && !this.isAssociated) {
				var deleteUrl = net.jazz.ajax._contextRoot +
				"/process-authoring/" + //$NON-NLS-1$ 
				(this.editor.isTeamArea ? "team-area" : "project-area") + //$NON-NLS-1$  //$NON-NLS-2$ 
				"/" + //$NON-NLS-1$ 
				itemId +
				"/description"; //$NON-NLS-1$
				var deferred = jazz.client.xhrDelete({
					url: deleteUrl,
					handleAs: "xml", //$NON-NLS-1$
					load: dojo.hitch(this, function(data){
						this.resourceUrl = null;
						this.hideAllLinks();
						this.showWelcomeSection();
						this.saveCallback();
						this.setDirty(false);
						this.saveAction = null;
					}),
					error: dojo.hitch(this, function(error){
						this.handleDeleteProcessDescriptionError(deferred, error);
						return error;
					})
				});
			} else if (this.resourceUrl) {
				var targetUrl = this.ownerUrl; //$NON-NLS-1$
				ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
					targetUrl: targetUrl,
					load: dojo.hitch(this, function(data, ioArgs){
						var associationUrl = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
						if (associationUrl) {
							this.updateAssociationForDiscarding(associationUrl, this.resourceUrl);
							this.saveCallback();
							this.saveAction = null;
						}
					}),
					error: dojo.hitch(this, function(error){ //no associate shared process description
						this.resourceUrl = null;
					})
				});
			}
		},
		
		handleDeleteProcessDescriptionError: function(deferred, error) {
			var errorHeader = ""; //$NON-NLS-1$
			error.headerMessage = this.messages.ProcessDescriptionEditorContainer_7;
			if (error.responseText) {
				error.message = error.responseText;
			}
			//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
			this.saveCallback(error);
		},
		
		populateAuthoringProcessDescription: function() {
			if(this.fetchError) {
				this.clearMessage();
				this._showFetchError();
				return;
			}
			
			if (this.resourceUrl && this.isAssociated) {
				this.isShared = true;
			} else {
				this.isShared = false;
			}
			
			this.hideAllLinks();
			if (!this.resourceUrl) {
				this.clearMessage();
				this.showWelcomeSection();
			} else {
                this.setupGadget(this.isAssociated ? ProcessAuthoringConstants.DISCARDTYPE_ASSOCIATION : ProcessAuthoringConstants.DISCARDTYPE_OWNER);
			}
		},

		showCreateLink: function() {
			dojo.style(this._createProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showImportLink: function() {
			dojo.style(this._importProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showAssociateLink: function() {
			if (this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_READ_SHARED_SUPPORT)) {
				dojo.style(this._associateProcessDescriptionLink, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
			}
		},
		
		showDiscardLink: function() {
            if (this.gadget) {
            	setTimeout(dojo.hitch(this, function() {
            		if (this.isAssociated) {
            			gadgets.rpc.call(this.gadget.id, ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SHOWLINK, null, "discardassociatelink"); //$NON-NLS-1$
            		} else {
            			gadgets.rpc.call(this.gadget.id, ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SHOWLINK, null, "discardownerlink"); //$NON-NLS-1$
            		}
            	}), 1500);
            } 
		},
		
		showBackToStartPageLink: function(){
            if (this.gadget) {
            	setTimeout(dojo.hitch(this, function() {
            		gadgets.rpc.call(this.gadget.id, ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SHOWLINK, null, "backtostartlink"); //$NON-NLS-1$
            	}), 1500)
            } else {
            	dojo.style(this._actionBar, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
			} 
		},
		
		onCreateProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.hideAllLinks();
			this.saveAction = ProcessAuthoringConstants.UPDATE_ACTION;
			this.setupGadget(ProcessAuthoringConstants.DISCARDTYPE_BACKTOSTART);
		},
		
		onImportProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.cleanContentNode();
			this.importPrivateProcessDescription();
			
		},
		
		onAssociateProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this.saveAction = ProcessAuthoringConstants.ASSOCIATE_ACTION;
			this.cleanContentNode();
			this.associateSharedProcessDescription();
		},
		
		onDiscardProcessDescription: function(evt) {
			dojo.stopEvent(evt);
			this._discardProcessDescription();
		},
		
		_discardProcessDescription: function() {
			this.showPendingDiscardInfo();
			this.hideAllLinks();
			this.saveAction = ProcessAuthoringConstants.DISCARD_ACTION;
			this.setDirty(true);
		},
		
		_backToStart: function() {
            if (this.changesPending()) {
                if (!confirm(this.saveAction === ProcessAuthoringConstants.ASSOCIATE_ACTION ? this.messages.ProcessDescriptionEditorContainer_12_2 : this.messages.ProcessDescriptionEditorContainer_12_1)) {
                	return;
                }
            }
			this.setDirty(false);
			this.hideAllLinks();
			this.showWelcomeSection();
		},
		
		onBackToStartPage:  function(evt) {
			dojo.stopEvent(evt);
			this._backToStart();
		},
		
		onGadgetDiscardProcessDescription: function() {
			this._discardProcessDescription();
		},
		
		onGadgetBackToStart: function() {
			this._backToStart();
		},
		
		onGadgetSaveSuccess: function(savedProcessDescriptionUrl) {
			this.inherited(arguments);
			this.hideAllLinks();
			this.showDiscardLink();
		},
		
		
		handleImportSuccess: function(args) {
			this.inherited(arguments);
			this.hideAllLinks();
			this.showDiscardLink();
		},
		
		handleAssociateSuccess: function(associatedProcessDescription) {
			this.inherited(arguments);
			this.hideAllLinks();
			this.showDiscardLink();
			this.saveCallback();
		},
		
		handleUnassociateSuccess: function() {
			this.inherited(arguments);
			this.populateAuthoringProcessDescription();
		},
		
		showWelcomeSection: function(){
			this.cleanContentNode();
			this.showCreateLink();
			this.showImportLink();
			this.showAssociateLink();
			dojo.style(this._welcomeSection, "display", ""); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		showPendingDiscardInfo: function(){
			this.cleanContentNode();
			var div = document.createElement("div"); //$NON-NLS-1$
            if (this.isAssociated) {
            	div.appendChild(document.createTextNode(this.messages.ProcessDescriptionEditorContainer_6_2));
            } else {
            	div.appendChild(document.createTextNode(this.messages.ProcessDescriptionEditorContainer_6_1));
            }
			this._contentNode.appendChild(div);
		},
		
		_showFetchError: function() {
			if (!this.fetchError) {
				return;
			}
			var msg;
			this.cleanContentNode();
			if (this.fetchError.dojoType == "popupBlocked") { //$NON-NLS-1$
				var div = document.createElement("div"); //$NON-NLS-1$
				var loginWidgetMessages = dojo.i18n.getLocalization("jazz.app.internal", "LoginWidgetMessages"); //$NON-NLS-1$ $NON-NLS-2$
	            div.appendChild(document.createTextNode(loginWidgetMessages.popupBlocked));
				this._contentNode.appendChild(div);
			} else {
				this.displayErrorMessage(this.fetchError);
			}
		},
		
		pendingAssociate: function() {
			this.hideAllLinks();
			this.showBackToStartPageLink();
			this.inherited(arguments);
		},
		
		doSave: function(saveCallback) {
			if (this.saveAction === ProcessAuthoringConstants.DISCARD_ACTION) {
				this.saveCallback = saveCallback;
				this.discardProcessDescription(this.editor.itemId);
			} else if (this.saveAction === ProcessAuthoringConstants.ASSOCIATE_ACTION) {
			    this.saveCallback = saveCallback;
				this.handleAssociate();
			} else {
				this.inherited(arguments);
			}
		}
	});
})();
