/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorContainer"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("jazz.opensocial.Gadget"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ResourceLinkPickerJazzDialog"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	 
	var ImportDialog = com.ibm.team.process.authoring.web.ui.internal.dialogs.ImportDialog;
	var ResourceLinkPickerJazzDialog = com.ibm.team.process.authoring.web.ui.internal.editors.ResourceLinkPickerJazzDialog;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.client.internal.ProcessAuthoringClient;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.authoring.web.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var OVERVIEW_TABID = "com.ibm.team.process.web.Overview"; //$NON-NLS-1$
	var messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorContainer", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web", "ui/internal/editors/templates/ProcessDescriptionEditorContainer.html"), //$NON-NLS-1$ //$NON-NLS-2$
		_gadgetURL: UIHelper.getURLPrefix() + "/web/com.ibm.team.process.authoring.web/ProcessDescriptionEditor", //$NON-NLS-1$
		hasChange: false,
		saveCallback: null,
		saveAction: null,
		isShared: false,
		isAssociated: false,
		resourceUrl: null,
		ownerUrl: null,
		processAuthoringPracticeId: null,
		processAuthoringPracticeElementId: null,
		
		constructor: function(args) {
			this.initialize(args);
		},
		
		postCreate: function() {
			this.inherited(arguments);
		},
		
		setupGadget: function(discardType) {
			this.cleanContentNode();
			
            var prefs = [];
			if (this.resourceUrl) {
				prefs[ProcessAuthoringConstants.PREFS_PD_RESOURCE] = this.resourceUrl;
			} else {
				prefs[ProcessAuthoringConstants.PREFS_PD_OWNER] = this.ownerUrl;
			}
			
			prefs[ProcessAuthoringConstants.PREFS_PD_SHARED] = this.isShared;
			prefs[ProcessAuthoringConstants.PREFS_PD_DISCARDTYPE] = discardType;
			
			var locale;
			if (this.editor.processLocale) {
				locale = this.editor.processLocale
				locale = locale.toLowerCase().replace("_", "-"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				locale = "en"; //$NON-NLS-1$
			}
            prefs[ProcessAuthoringConstants.PREFS_PROCESS_LOCALE] = locale;
            
            prefs[ProcessAuthoringConstants.PROCESS_AUTHORING_READ_SHARED_SUPPORT] = this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_READ_SHARED_SUPPORT);
            prefs[ProcessAuthoringConstants.PROCESS_AUTHORING_WRITE_SHARED_SUPPORT] = this.assertOperation(ProcessAuthoringConstants.PROCESS_AUTHORING_WRITE_SHARED_SUPPORT); //$NON-NLS-1$

			if (this.processAuthoringPracticeId || this.processAuthoringPracticeElementId) {
				prefs["isLocateNeeded"] = true;        //$NON-NLS-1$
			}

			this.gadget = new jazz.opensocial.Gadget({
				url: this._gadgetURL,
				prefs: prefs
			});
			this._contentNode.appendChild(this.gadget.domNode);
			
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_NAVIGATE, dojo.hitch(this, this.onGadgetNavigate));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_DISPLAYMESSAGE, dojo.hitch(this, this.onGadgetDisplayMessage));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_LOADED, dojo.hitch(this, this.onGadgetLoaded));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_TOGGLEDIRTY, dojo.hitch(this, this.onGadgetDirty));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVESUCCESS, dojo.hitch(this, this.onGadgetSaveSuccess));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVEERROR, dojo.hitch(this, this.onGadgetSaveError));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_REGISTERED, dojo.hitch(this, this.onGadgetRegistered));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_DISCARD, dojo.hitch(this, this.onGadgetDiscardProcessDescription));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_BACKTOSTART, dojo.hitch(this, this.onGadgetBackToStart));
		},
		
		///////////////////////////////////////////////////////////////////////////////////////////
		// Gadget Events
		///////////////////////////////////////////////////////////////////////////////////////////
		onGadgetNavigate: function(url) {
			//TODO: Need to change to use dojo.hash after 114144 is fixed 
			window.location.replace(url);
		},
		
		onGadgetDisplayMessage: function(msg, type) {
			this.displayMessage(msg, type);
		},
		
		onGadgetLoaded: function() {
			this.clearMessage();
		},
		
		onGadgetDirty: function(isDirty, editingProcessDescriptionName) {
			this.setDirty(isDirty, editingProcessDescriptionName);
		},
		
		onGadgetSaveSuccess: function(savedProcessDescriptionUrl) {
			this.resourceUrl = savedProcessDescriptionUrl;
			this.saveResponse();
			this.setDirty(false);
		},
		
		onGadgetSaveError: function(errObject) {
			this.saveResponse(errObject);
		},
			
		onGadgetRegistered: function() {
			if (this.gadget) {
				if (this.processAuthoringPracticeId || this.processAuthoringPracticeElementId) {
					gadgets.rpc.call(this.gadget.id, ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_LOCATE, null, this.processAuthoringPracticeId, this.processAuthoringPracticeElementId); //$NON-NLS-1$
				}
			}
		},
		
		///////////////////////////////////////////////////////////////////////////////////////////
		// Override Functions
		///////////////////////////////////////////////////////////////////////////////////////////	
		displayMessage: function(msg, type) {
			if (msg) {
				if (type === "INFO") { //$NON-NLS-1$
					this.displayPendingMessage(msg)
				} else if (type === "OK") { //$NON-NLS-1$
					this.displaySuccessMessage(msg);
				} else {
					this.displayErrorMessage(msg);
				}
			}
		},
		
		displayPendingMessage: function(msg) {
			
		},
		
		displaySuccessMessage: function(msg) {
			
		},
		
		displayErrorMessage: function(msg) {
			
		},
		
		clearMessage: function() {
		},
		
		setDirty: function(isDirty, editingProcessDescriptionName) {
		},
			
		canSave: function() {
		},
		
		refresh: function() {
		},
		
		assertOperation: function() {
			return true;
		},
		
		initialize: function(args) {
		},
			
		getOwnerName: function() {
		},		

		importPrivateProcessDescription: function() {
			var importDialog = new ImportDialog({
				processDescriptionOwnerUrl: this.ownerUrl,
				processDescriptionOwnerName: this.getOwnerName()
			});
			this.connect(importDialog, "onSuccess", "handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(importDialog, "onCancel", "handleCancelImport");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(importDialog.dialog, "onClose", "handleCancelImport");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		handleImportSuccess: function(args) {
			this.setDirty(false);
			this.resourceUrl = args.privateProcessDescriptionUrl;
			this.isAssociated = false;
			this.isImportSucceeded = true;
		},
		
		handleCancelImport: function() {
			this.setDirty(false);
			if (this.isImportSucceeded) {
				this.refresh();
			}
		},
		
		associateSharedProcessDescription: function() {
			this.associateDialog = new ResourceLinkPickerJazzDialog({
				processDescriptionOwnerName: this.getOwnerName(),
				processDescriptionOwnerUrl: this.ownerUrl,
				associateSharedProcessDescriptionURL: this.resourceUrl,
				dialogTitle: messages.AssociateDialog_0,
				AddCloseButtonLabel: messages.AssociateDialog_1,
				allowMultiple: false,
				resourceGroups: [{
					type: messages.AssociateDialog_2,
					list: []
				}]
			});
			this.connect(this.associateDialog, "_onSelectionChange", dojo.hitch(this, function(e) { //$NON-NLS-1$
				this.associateDialog.addCloseButton.disabled = false;
			}));
			
			this.connect(this.associateDialog, "_onAddClose", "pendingAssociate");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.associateDialog, "onCancel", "handleCancelAssociate");//$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.associateDialog.dialog, "onClose", "handleCancelAssociate");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		pendingAssociate: function() {
			this.associateDialog.addCloseButton.disabled = true;
			this.setDirty(true);
			this.associatingProcessDescriptionUrl = this.associateDialog.resourceSelector.options[this.associateDialog.resourceSelector.selectedIndex].resourceUrl;
			this.associatingProcessDescriptionName = this.associateDialog.resourceSelector.options[this.associateDialog.resourceSelector.selectedIndex].text;
			if (this.associatingProcessDescriptionUrl) {
				if (!this.associatingDiv) {
					this.associatingDiv = document.createElement("div"); //$NON-NLS-1$
				} else {
					dojo.empty(this.associatingDiv);
				}
				
				var br = document.createElement("br"); //$NON-NLS-1$
				this.associatingDiv.appendChild(br);
				
				var textSpan = document.createElement("span"); //$NON-NLS-1$
				dojo.addClass(textSpan, "normalContent"); //$NON-NLS-1$
				textSpan.appendChild(document.createTextNode(messages.ProcessDescriptionEditor_15));
				this.associatingDiv.appendChild(textSpan);
				
				var linkSpan = document.createElement("span"); //$NON-NLS-1$
				dojo.addClass(linkSpan, "boldContent"); //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				link.href = this.associatingProcessDescriptionUrl;
				link.appendChild(document.createTextNode(this.associatingProcessDescriptionName));
				linkSpan.appendChild(link);
				this.associatingDiv.appendChild(linkSpan);
				
				if (this._resourceLink) {
					this._resourceLink.destroyRecursive();
				}
				this._resourceLink = new ResourceLink({
					'presentationUri': this.associatingProcessDescriptionUrl, //$NON-NLS-1$ //$NON-NLS-2$
					'lazyFetch': true //$NON-NLS-1$
				}, link);
				
				this.cleanContentNode();
			    this._contentNode.appendChild(this.associatingDiv);
			}
			this.associateDialog.dialog.close();
		},
		
		handleAssociate: function() {
			this.deleteOldAssociateForTargetThenAddNew();
		},
		
		deleteOldAssociateForTargetThenAddNew: function() {
			//check if there is a association for target
			ProcessAuthoringClient.checkAssociateSharedProcessDescriptionForProcessArea({
				targetUrl: this.associateDialog.processDescriptionOwnerUrl,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.oldAssociationURL = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					ProcessAuthoringClient.getAssociation({
						url: this.oldAssociationURL,
						load: dojo.hitch(this, function(data, ioArgs) {
							var newTargets = [];
							var docElement = data.documentElement;
							dojo.forEach(docElement.childNodes, function(node) {
								if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
									if (UIHelper.isSpecifiedNode(node, "source", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
										var sourceUrl = UIHelper.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
										if (sourceUrl !== null) {
											this.oldAssociateSharedProcessDescriptionURL = sourceUrl;
										}
									}
									if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
										var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
										dojo.forEach(targetNodes, function(targetNode) {
											var oldTarget = {
												title: null,
												url: null
											};
											oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
											oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
											if (oldTarget.url !== this.associateDialog.processDescriptionOwnerUrl) {
												newTargets.push(oldTarget);
											}
										}, this);
									}
								}
							}, this);
							ProcessAuthoringClient.updateAssociation({
								associationURL: this.oldAssociationURL,
								newTargets: newTargets,
								sourceUrl: this.oldAssociateSharedProcessDescriptionURL,
								load: dojo.hitch(this, function(data, ioArgs) {
									this.addNewSharedProcessDescription();
								}),
								error: dojo.hitch(this, function(error) {
									this.saveErrorResponse(error);
								})
							});
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) { //no associate shared process description
					//put association
					this.addNewSharedProcessDescription();
				})
			});
		},
		
		addNewSharedProcessDescription: function() {
			var associatingProcessDescriptionUrl = this.associatingProcessDescriptionUrl;
			ProcessAuthoringClient.checkAssociationForProcessDescription({
				sourceUrl: associatingProcessDescriptionUrl,
				load: dojo.hitch(this, function(data, ioArgs) {
					var associationURL = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					//put association
					this.updateAssociationForAdding(associationURL, associatingProcessDescriptionUrl);
				}),
				error: dojo.hitch(this, function(error) { //no associate shared process description
					//post association
					ProcessAuthoringClient.createAssociation({
						sourceUrl: associatingProcessDescriptionUrl,
						targetUrl: this.associateDialog.processDescriptionOwnerUrl, //$NON-NLS-1$
						targetName: this.associateDialog.processDescriptionOwnerName,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleAssociateSuccess(associatingProcessDescriptionUrl);
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				})
			});
			return;
		},
		
		updateAssociationForAdding: function(associationURL, associatingProcessDescriptionUrl) {
			ProcessAuthoringClient.getAssociation({
				url: associationURL,
				load: dojo.hitch(this, function(data, ioArgs) {
					var newTargets = [];
					var docElement = data.documentElement;
					dojo.forEach(docElement.childNodes, function(node) {
						if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
							if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
								var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
								dojo.forEach(targetNodes, function(targetNode) {
									var oldTarget = {
										title: null,
										url: null
									};
									oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
									oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
									newTargets.push(oldTarget);
								}, this);
							}
						}
					}, this);
					
					newTargets.push({
						title: this.associateDialog.processDescriptionOwnerName,
						url: this.associateDialog.processDescriptionOwnerUrl
					});
					
					ProcessAuthoringClient.updateAssociation({
						associationURL: associationURL,
						newTargets: newTargets,
						sourceUrl: associatingProcessDescriptionUrl,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleAssociateSuccess(associatingProcessDescriptionUrl);
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) {
					this.saveErrorResponse(error);
				})
			});
		},
		
		updateAssociationForDiscarding: function(associationURL, associatingProcessDescriptionUrl) {
			ProcessAuthoringClient.getAssociation({
				url: associationURL,
				load: dojo.hitch(this, function(data, ioArgs) {
					var newTargets = [];
					var docElement = data.documentElement;
					dojo.forEach(docElement.childNodes, function(node) {
						if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
							if (UIHelper.isSpecifiedNode(node, "targets", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
								var targetNodes = UIHelper.getNodes(node.childNodes, "target", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
								dojo.forEach(targetNodes, function(targetNode) {
									var oldTarget = {
										title: null,
										url: null
									};
									oldTarget.title = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
									oldTarget.url = UIHelper.getAttributeNode(targetNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
									if (oldTarget.url !== this.ownerUrl) {
										newTargets.push(oldTarget);
									}
								}, this);
							}
						}
					}, this);
					
					ProcessAuthoringClient.updateAssociation({
						associationURL: associationURL,
						newTargets: newTargets,
						sourceUrl: associatingProcessDescriptionUrl,
						load: dojo.hitch(this, function(data, ioArgs) {
							this.handleUnassociateSuccess();
						}),
						error: dojo.hitch(this, function(error) {
							this.saveErrorResponse(error);
						})
					});
				}),
				error: dojo.hitch(this, function(error) {
					this.saveErrorResponse(error);
				})
			});
		},
		
		handleUnassociateSuccess: function() {
			this.setDirty(false);
			this.resourceUrl = null;
			this.isAssociated = false;
			this.deactivateTab();
			this.activateTab();
		},
		
		handleAssociateSuccess: function(associatedProcessDescription) {
			this.setDirty(false);
			if (associatedProcessDescription !== null) {
				this.resourceUrl = associatedProcessDescription;
				this.isAssociated = true;
			}
			this.deactivateTab();
			this.activateTab();
			this.isAssociateSucceeded = true;
			this.associateDialog.dialog.close();
		},
		
		handleCancelAssociate: function() {
			if (this.isAssociateSucceeded && this.isAssociated) {
				this.isAssociateSucceeded = false;
				this.refresh();
			}
		},
		
		doSave: function(saveCallback) {
			if (this.gadget) {
				gadgets.rpc.call(this.gadget.id, ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVE, null); //$NON-NLS-1$
			}
			this.saveCallback = saveCallback;
		},
		
		changesPending: function() {
			return this.hasChange;
		},
		
		saveResponse: function(errObject) {
			if (this.saveCallback) {
				//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
				this.saveCallback(errObject);
				this.saveCallback = null;
			} else {
				this.displayErrorMessage(errObject);
			}
		},
		
		saveErrorResponse: function(errorObj) {
			if (this.saveCallback) {
				//call AbstractProcessAreaEditor._saveExtensionPageCallback(errorObject);
				this.saveCallback(errorObj);
				this.saveCallback = null;
			} else {
				this.displayErrorMessage(errorObj);
			}
		},
		
		cleanContentNode: function() {
			if (this.gadget) {
				this.gadget.destroyRecursive();
				this.gadget = null;
			}
			
			dojo.empty(this._contentNode);
		},
		
		uninitialize: function() {
			if (this.gadget) {
				this.gadget.destroyRecursive();
			}
			
			this.inherited(arguments);
		}
	});
})();
