/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorGadget"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditor"); //$NON-NLS-1$
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Separator"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.TwoStateButton"); //$NON-NLS-1$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.internal.ProcessAuthoringConstants;
	
	dojo.declare("com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditorGadget", [com.ibm.team.process.authoring.web.ui.internal.editors.ProcessDescriptionEditor], { //$NON-NLS-1$
		discardType: null,
		
		//constants definition
		constructor: function(args) {
			if (args.isLocateNeeded == "true") { //$NON-NLS-1$
				this.locateURLReceivedHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_LOCATE_URL_RECEIVED, this, this._attemptLocating);
			}
			this.practicesLoadDoneHandle = dojo.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE, this, this.practicesLoadDone);
            this._discardIconSrc = "com.ibm.team.process.authoring.web/graphics/icons/delete-button.gif"; //$NON-NLS-1$
            this._dissociateIconSrc =  "com.ibm.team.process.authoring.web/graphics/icons/dis-proc-description_co.gif"; //$NON-NLS-1$
		},
		
		_attemptLocating: function() {
			if (!this.canLocate) {
				this.canLocate = true;
				return;
			} else {
				if (this.locateURL) {
					this._linkAction(this.locateURL);
					if (this.practicesLoadDoneHandle) {
						dojo.unsubscribe(this.practicesLoadDoneHandle);
						this.practicesLoadDoneHandle = null;
					}
					if (this.locateURLReceivedHandle) {
						dojo.unsubscribe(this.locateURLReceivedHandle);
						this.locateURLReceivedHandle = null;
					}
					this.locateURL = null;
					this.canLocate = false;
				}
			}
		},
		
		practicesLoadDone: function() {
			if (this.isLocateNeeded) {
				this._attemptLocating();
			}
			this.clearLoadingMessage();
		},
		
		clearLoadingMessage: function() {
			//notice the container to remove the "loading..." message
			gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_LOADED, null); //$NON-NLS-1$
		},
		
		_initialize: function(args) {
		
			this.isGadget = true;
			
			//gadgets is defined in opensocial container. 
			var prefs = new gadgets.Prefs();
			args.resource = prefs.getString(ProcessAuthoringConstants.PREFS_PD_RESOURCE);
			args.ownerURL = prefs.getString(ProcessAuthoringConstants.PREFS_PD_OWNER);
			args.shared = prefs.getString(ProcessAuthoringConstants.PREFS_PD_SHARED);
			this.discardType = prefs.getString(ProcessAuthoringConstants.PREFS_PD_DISCARDTYPE);
			if (args.shared) {
				this.isShared = args.shared === "true" ? true : false; //$NON-NLS-1$
			}
			
			args.isLocateNeeded = prefs.getString("isLocateNeeded"); //$NON-NLS-1$
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVE, dojo.hitch(this, function(needRefresh) {
				if (typeof needRefresh != "undefined") { //$NON-NLS-1$
					this.refreshAfterSave = needRefresh;
				}
				this.doSave();
			}));
			gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_LOCATE, dojo.hitch(this, function(practiceId, practiceElementId) {
				var url;
				if (practiceElementId) {
					url = UIHelper.getFullProcessAuthoringRoot() + "/elements/" + practiceElementId; //$NON-NLS-1$
				} else if (practiceId) {
					url = UIHelper.getFullProcessAuthoringRoot() + "/practices/" + practiceId; //$NON-NLS-1$
				}
				this.locateURL = url;
				if (this.locateURLReceivedHandle) {
					dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_LOCATE_URL_RECEIVED);
				}
			}));
            
            gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_REFRESH, dojo.hitch(this, this.onRefresh)); //$NON-NLS-1$
            gadgets.rpc.register(ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SHOWLINK, dojo.hitch(this, this.showDiscardLink)); //$NON-NLS-1$		
			this.inherited(arguments);
			this.enableLock = parent.location.search.toLowerCase().indexOf(ProcessAuthoringConstants.ENABLELOCK) !== -1;
		},
		
		postCreate: function() {
			this.inherited(arguments);

			//gadgets.window.adjustHeight is defined in gadget feature dynamic-height. 
			//This feature is already included in processDescriptionEditor.xml, so it can be invoked directly.
			gadgets.window.adjustHeight();
			setTimeout(dojo.hitch(this, function() {
				gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_REGISTERED, null); //$NON-NLS-1$
			}), 1000);
			
			//bug 149168
			if (dojo.isIE) {
				dojo.style(this.domNode.ownerDocument.documentElement, "overflow", "hidden");  //$NON-NLS-1$ //$NON-NLS-2$
			}
		},
		
		setupCommandBar: function() {
			this.commandBar = new jazz.ui.Toolbar();
            
            if (!this.viewOnly) {
            	this.editButton = new jazz.ui.toolbar.TwoStateButton({
            		href: "#", //$NON-NLS-1$
            		imgSrc: this._editModeIconSrc,
            		title: this.messages.AbstractPracticesEditor_12,
            		onClick: dojo.hitch(this, this.toggleViewEditMode)
            	});
            	this.commandBar.addChild(this.editButton);
			}
			
			
			this.copyUrlButton = new jazz.ui.toolbar.Button({
    			imgSrc: this._copyUrlIconSrc, //$NON-NLS-1$ $
    			title: this.messages.ProcessDescriptionEditor_30,
    			onClick: dojo.hitch(this, function(evt) {
    				dojo.stopEvent(evt);
    				this.onCopyResourceUrl(this.resourceURL); //$NON-NLS-1$
    			})
    		});
			this.commandBar.addChild(this.copyUrlButton);
			
			this.exportProcessDescriptionButton = new jazz.ui.toolbar.Button({
				href: "#", //$NON-NLS-1$
               	imgSrc: this._exportIconSrc,
               	title: this.messages.ProcessDescriptionEditorHTML_4,
				onClick: dojo.hitch(this, this.exportProcessDescription)
			});
			this.commandBar.addChild(this.exportProcessDescriptionButton);
            
            var splitter = new jazz.ui.toolbar.Separator();
            this.commandBar.addChild(splitter);
			this.commandsContainer.appendChild(this.commandBar.domNode);
			this.showDiscardLink(this.discardType);			
		},
		
		discardProcessDescription: function() {
			gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_DISCARD, null, this.resourceURL); //$NON-NLS-1$
		},
		
		backToStart: function() {
			gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_BACKTOSTART, null, this.resourceURL); //$NON-NLS-1$
		},
		
		showDiscardLink: function(linkType) {
			
			if (!linkType) {
				return;
			}
            
            //remove previous button first
            if (this.discardButton) {
            	this.discardButton.destroyRecursive();
            	this.discardButton = null;
            }
            
            switch (linkType) {
            	case ProcessAuthoringConstants.DISCARDTYPE_BACKTOSTART:
            		this.discardButton = new jazz.ui.toolbar.Button({
            			href: "#", //$NON-NLS-1$
            			imgSrc: this._discardIconSrc,
            			title: this.messages.ProcessDescriptionEditor_28,
            			onClick: dojo.hitch(this, this.backToStart)
            		});
            		this.commandBar.addChild(this.discardButton);
            		break;
            	case ProcessAuthoringConstants.DISCARDTYPE_OWNER:
            		this.discardButton = new jazz.ui.toolbar.Button({
            			href: "#", //$NON-NLS-1$
            			imgSrc: this._discardIconSrc,
            			title: this.messages.ProcessDescriptionEditor_28,
            			onClick: dojo.hitch(this, this.discardProcessDescription)
            		});
            		this.commandBar.addChild(this.discardButton);
            		break;
            	default: //discardassociatelink
            		this.discardButton = new jazz.ui.toolbar.Button({
            			href: "#", //$NON-NLS-1$
            			imgSrc: this._dissociateIconSrc,
            			title: this.messages.ProcessDescriptionEditor_29,
            			onClick: dojo.hitch(this, this.discardProcessDescription)
            		});
            		this.commandBar.addChild(this.discardButton);
            		
            		break;
            }
		},
		
		setupBreadcrumbs: function() {
		},
		
		resetAllFields: function() {
			this.inherited(arguments);
			if (this.detailEditor) {
				this.detailEditor.displayOwner(false);
			}
		},
		
		navigateToPractice: function(practiceResource) {
			//work around: use user prefs to pass parameter
			var prefs = new gadgets.Prefs();
			prefs.set(ProcessAuthoringConstants.PREFS_PRACTICE_RESOURCE, practiceResource);
			gadgets.views.requestNavigateTo("practice", { //$NON-NLS-1$
				resource: practiceResource
			});
		},
		
		toggleDirty: function(isDirty) {
			dojo.toggleClass(this.modifiedFlag, "hide", !this.hasChanges); //$NON-NLS-1$
			gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_TOGGLEDIRTY, null, isDirty); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		toggleViewEditMode: function(e) {
			this.inherited(arguments);			
		},
		
		getResult: function(results) {
			if (this.inherited(arguments)) {
				gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVESUCCESS, null, this.resourceURL); //$NON-NLS-1$
			} else {
				for (var i = 0; i < results.length; i++) {
					var result = results[i];
					if (!result.success) {
						gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVEERROR, null, result); //$NON-NLS-1$
						break;
					}
				}
			}
		},
		
		saveResultCallback: function(errObject) {
			if (errObject) {
				gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVEERROR, null, errObject); //$NON-NLS-1$
			} else {
				gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_SAVESUCCESS, null, this.resourceURL); //$NON-NLS-1$
			}
		},
		
		displaySuccessMessage: function(msg) {
			this.displayMessageInProcessAreaEditor(msg, "OK"); //$NON-NLS-1$
		},
		
		displayErrorMessage: function(msg) {
			this.displayMessageInProcessAreaEditor(msg, "ERROR"); //$NON-NLS-1$
		},
		
		displayWaitingMessage: function(msg) {
			this.displayMessageInProcessAreaEditor(msg, "INFO"); //$NON-NLS-1$
		},
		
		displayMessageInProcessAreaEditor: function(msg, cssClass) {
			gadgets.rpc.call("", ProcessAuthoringConstants.RPCSERVICE_PROCESSDESCRIPTION_DISPLAYMESSAGE, null, msg, cssClass); //$NON-NLS-1$
		},
		
		uninitialize: function() {
			if (this.practicesLoadDoneHandle) {
				dojo.unsubscribe(this.practicesLoadDoneHandle);
				this.practicesLoadDoneHandle = null;
			}
			if (this.locateURLReceivedHandle) {
				dojo.unsubscribe(this.locateURLReceivedHandle);
				this.locateURLReceivedHandle = null;
			}
			if (this.commandBar) {
				this.commandBar.destroyRecursive();
			}
			this.inherited(arguments);
		}
	});
})();
