/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	// Reports View
	'sharedReports': "Shared Reports",
	'myReports': "My Reports",
	'reportTemplates': "Report Templates",
	'createReport': "Create Report",
	'createReportFromTemplate': "Create Report from Template",
	'reportColon': "Report: ",
	'report': "Report",
	'newReport': "New Report",
	
	// Report Viewer
	'run': "Run",
	'refresh': "Refresh",
	'loading': "Loading...",
	'loadingReport': "Loading Report",
	'format': "Format: ",
	'parameters': "Parameters",
	'submit': "Submit",
	'save': "Save",
	'closeParameters': "Close Parameters",
	'saveCopy': "Save Copy",
	'name': "Name: ",
	'cancel': "Cancel",
	'close': "Close",
	'missingReqParam': "Missing Required Parameter: ${0}",
	'parametersTooltip': "Click to Edit Parameters",
	'exportTitle': "Export...",
	'viewInPrintableFormatTitle': "View Report in Printable Format",
	'nowDefaultReport': "This is now the default report.",
	'setAsDefaultReport': "Set as Default Report",
	'exportOperationNotSupported': "Export operation not supported for this report.",
	'msgProjectAreaIsDifferent': "The project area for this report (${0}) is different from the project area context selected for the page (${1}).",	
	'msgProjectAreaIsDifferentDetails': "The page displayed has a project area context which is selected using the drop-down selection shown in the header. " +
		"This report may display data from a different project area than indicated in the drop-down selection.",
	
	// Reports Welcome
	'welcomeGettingStarted': "To get started, view an existing report by selecting it from the left panel.",
	'welcomeToReports': "Welcome to Reports",
	'welcomeStarted1': "To get started, ",
	'welcomeStarted2': "create a new report ",
	'welcomeStarted3': "or view an existing report by selecting it from the left panel.",
	
	// Report Parameter Messages
	'trueValue': "Yes",
	'falseValue': "No",
	'noSelection': "(No Selection)",
	'zeroSelected': "0 of 0 selected",
	'numSelected': "${0} of ${1} selected",
	'numSelectedTotal': "${0} of ${1} selected (${2})",
	'numTotal': "&nbsp;(total ${0})",
	'numItemsSelected': "(${0} items selected)",
	'loading': "Loading...",
	'selectAll': "Select All",
	'deSelectAll': "Deselect All",
	'addMoreValues': "Add more values",
	'addValuesDialogTitle': "Add Parameter Values",
	'currentIteration': 'Current Iteration',
	'myTeamAreas': 'My Team Areas',
	'currentContributor': 'Current Contributor',
	'noItemsSelected': 'No items selected',
	
	// List Box
	'msgLoading': "Loading...",
	
	// Admin Section
	'admin': "Admin",
	'needSnapshotSelection': "Need a snapshot selected",
	'requestSubmitted': "Request submitted.",
	'waitingForResponse': "Waiting for response.",
	'checkActiveServicesInAdminPage': "Check the Active Services in Admin Page for status.",
	'responseReceived': "Response received.",
	'lastRequestSucceeded': "Last request succeeded.",
	'errorInResponse': "Error in response.",
	'lastRequestFailed': "Last request failed.",
	'schemaDatabaseName': "Schema Database Name: ${0}",
	'schemaVersion': "Schema Version:       ${0}",
	'tableLogicalName': "Table Logical Name:",
	'tableDatabaseName': "Table Database Name:",
	'fieldLogicalName': "Field Logical Name",
	'fieldDatabaseName': "Field Database Name",
	'fieldLogicalType': "Field Logical Type",
	'fieldDatabaseType': "Field Database Type",
	'listAllTables': "List All Tables",
	'updateSnapshotData': "Update Snapshot Data",
	'updateAllSnapshotData': "Update All Snapshot Data",
	
	// New Folder Dialog
	'newFolder': "New Folder",
	'teamArea': "Project/Team Area: ",
	'ok': "OK",
	
	// IncludeArchived
	'includeArchived': "Include Archived",
	
	// FolderWidget
	'newFolderDotDotDot': "New Folder...",
	'rename': "Rename",
	'deleteMsg': "Delete", // Note: do NOT use 'delete' as it is a reserved word
	'newName': "New name:",
	'invalidNameEntered': "Invalid name entered.",
	'confirmDelFolder': "Are you sure you wish to delete this folder and all the reports in it?",
	'newFolderName': "New folder name:",
	'edit': "Edit",
	
	// ReportTemplatesNavigator
	'confirmDelTemplate': "Are you sure you wish to delete this report template?",
	'deleteTemplate': "Delete",
	'editTemplate': "Edit",
	'newTemplateDotDotDot': "Create New Template...",
	'findTemplatesDotDotDot': "Deploy New Templates...",
	
	// QueryWidget
	'confirmDelReport': "Are you sure you wish to delete this report?",
	'isNowDefaultReport': "${0} is now the default report.",
	
	// New Report Editor
	'description': "Description: ",
	'folder': "Folder: ",
	'template': "Template: ",
	'pleaseSelectTemplate': "Please select a template.",
	'pleaseSelectFolder': "Please select a folder.",
	
	// Error messages
	'handleSetAsDefaultError': "Error setting default report: ${0}",
	
	// Select Report Dialog
	'selectReportTemplate': "Select Report Template",
	'selectTheReportTemplate': "Select the report template to display",
	
	// Report Template Editor
	'reportTemplate': "Report Template",
	'reportCustomTemplate': "Custom Report Template",
	'availableCustomReports': "Available Custom Reports:",
	'identifier': "Identifier:",
	'resources': "Resources",
	'shared': "Shared",
	'supportsCaching': "Supports data caching",
	'invalidFileName': "An error occured during file upload.\nThis will happen when an invalid fully qualified file name is provided.",
	'errorUploadingFile': "Error uploading file: ${0}",
	'general': "General",
	'sharing': "Project/Team Area",
	'contents': "Contents",
	'caching': "Caching",
	'upload': "Select a local report design file to replace the contents of this template.",
	'sharingHeader': "Select a project/team area to associate the item with. This is required even if the item is not shared with other contributors.",
	'resourcesHeader': "Manage attached resource files used by this report template. Select a local resource file to upload.",
	'resource': "Resource",
	'actions': "Actions", 
	'newResource': "New Resource",
	'uploadNewContent': "Upload New Content",
	'clickToEdit': "Click to edit",
	'selectAResource': "Select a local resource file to upload.",
	'reportDescription': "${0} Report",
	'errorUnhelpful':  "An error occurred which did not produce a helpful message.",
	'restore': "If this is an out-of-the-box template, you can restore the contents to those shipped with the product.",
	'restoreInitialContents': "Restore Initial Contents",
	'contentsRestored': "The report template has been restored to its initial contents.",
	'cannotRestoreContents': "Cannot restore contents until the new report template has been saved.",
	'planning': "Planning",
	'planningMessage': "Set this report template as the default report shown in the planning editor.",
	'cannotSetAsPlanningReport': "Cannot set as default until the new report template has been saved.",
	'defaultReportSet': "This report template has been set as the default planning report.",
	'customReportServerInvalid': "Cannot reach the IBM Rational Reporting Server. Please check network connectivity and verify the server location is correct and the server is running.",
	'noCognosReportsAvailable': "There are no custom reports available on the IBM Rational Reporting Server. Create a report on the Reporting Server before creating a Custom Report Template.",
	'missingRequiredFields': "Fill in all required fields prior to saving.",
	'loadingCustomReportTemplates': "Loading Custom Reports",
	'templateSavedSuccessfully': "Report template saved successfully.",
	
	// Deploy Templates Viewer
	'noTemplatesFound': "No new report templates were found.",
	'deployTemplates': "Deploy Templates",
	'deployNewTemplates': "Deploy New Report Templates",
	'deployNewTemplatesHeading': "Select templates",
	'deployNewTemplatesText': "Below are all of the available report templates which are not already deployed to the selected project/team area. Select those you wish to deploy, and click \"Deploy Templates\".",
	'deployingNewTemplates': "Deploying new report templates.",
	'deployingTemplatesSuccess': "New report templates deployed successfully.",
	'noTemplatesSelected': "No report templates were selected.",
	
	// Folder editor
	'folderHeading': "Folder",
	
	// ReportsComponentMenu
	'allSharedReports': "All Shared Reports",
	'createReportTemplate': "Create Report Template",
	'allHeading': "All Reports",
	'allShared': "All Shared",
	'allMine': "All Mine",
	'queries': "Queries",
	'welcomeToReports': "Welcome to Reports",
	'customizeReport': "Customize Report",
	'performAdditional': "Perform Additional Reporting Tasks",
	
	// AllReportsTab
	'allReportsNone': "No reports found.",
	'allTemplatesNone': "No report templates found.",
	'allReportsSearching': "Searching reports",
	'createFolder': "Create Folder",
	'createNewTemplate': "Create New Template",
	'createNewTemplateFromCustomReport': "Create New Template from Custom Report",
	'deployNewTemplates': "Deploy New Templates",
	'selectView': "Select View:",
	'allFolders': "All Folders",
	'deletionSuccessful': "Report template successfully deleted",
	
	// New Reports Welcome
	'accessAndManage': "Access and manage your work:",
	'useTheNavigation': "Use the <b>navigation bar drop-down menu</b> to create resources or to access existing resources.",
	'searchForResources': "Search for resources with <b>quick search</b>.",
	'trackResourcesAvailable': "Track resources available from <b>navigation bar drop-down menu</b> and <a class='img-db-mini' href=\"/clmhelp/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html\" target=\"_blank\">Mini Dashboard</a>.",
	'showMe': "Show me >",
	'viewReports': "View reports",
	'browseYourProject': "Browse available reports, to select and view a report.",
	'createAReport': "Create report from template",
	'createAReportFrom': "Create a report from an existing template.",
	'organizeYourReports': "Organize your reports",
	'organizeYourReportsBy': "Organize your reports by creating folders and nesting folders.",
	'performAdditionalReporting': "Perform additional reporting tasks",
	'rrdiRequired': "Rational Reporting for Development Intelligence is required to perform additional reporting tasks. Contact your Administrator.",
	'additionalReportingDescription': "Customize, author, and manage report templates using Rational Reporting for Development Intelligence.",
	'learnMoreAbout': "Learn more about reporting >",
	
	//Author Custom Reports
	'authorCustomReportsTitle' : "Author a Custom Report Template",
	'customReportsNotInstalled' : "Rational Reporting for Development Intelligence is required to author custom report templates but is not installed or is not configured properly.",
	'customReportsNotInstalledInstructions' : "Instructions can be found on the ",
	'customReportsNotInstalledLink' : "CLM Reporting Wiki Page.",
	'customReportsNotInstalledNonAdmin' : "Contact an Administrator."
})